program kuTrayDEMO;

uses
  Forms,
  IniFiles,
  SysUtils,
  Windows,
  kuModul,
  kuTray, //     uses      Source          (      )
  Main in 'Main.pas' {Form1},
  Unit2 in 'Unit2.pas' {Form2};

{$R *.RES}

var
  i: integer;
  s: string;
  ini: TIniFile;

begin
Application.Initialize;
Application.Title := 'kuTrayDEMO';
Application.CreateForm(TForm1, Form1);
Application.CreateForm(TForm2, Form2);



{$REGION '  settings.ini   '}


s := Path_App + 'settings.ini';

if FileExists(s)

then
begin

  ini := TiniFile.Create(s);

  try
      //Close to tray
      Form1.CloseToTray := ini.ReadBool('Settings', 'CloseTotray', Form1.ch_CloseToTray.Checked);
      Form1.ch_CloseToTray.Checked := Form1.CloseToTray;


      //Icon in
      i := ini.ReadInteger( 'Settings', 'IconIn', 2 );
      Form1.cb_IconOnRestore.ItemIndex := i;
      _IconIn := IntToIconIn(i);
      //  Form1.OnShow  ShowIconIn


      //Run minimized to tray
      Form1.ch_RunMinimizedToTray.Checked := ini.ReadBool('Settings', 'RunMinimizedToTray', Form1.ch_RunMinimizedToTray.Checked);
      if Form1.ch_RunMinimizedToTray.Checked then MinimizeToTray;

  finally
      ini.Free;
  end;

end

else
begin
    //Icon in
    _IconIn := IntToIconIn(Form1.cb_IconOnRestore.ItemIndex);

    //Close to tray
    Form1.CloseToTray := Form1.ch_CloseToTray.Checked;
end;



_PopupMenuTray := Form1.pmTray;



{$ENDREGION}



//  Form1.Show    ShowIconIn


Application.Run;
end.
