unit About;
//ver 2014.03.13

interface

uses
  Classes, Forms, Controls, StdCtrls, ComCtrls, ExtCtrls, Graphics, Buttons, pngimage,

  Main,
  Individual,
  kuModul,
  kuShell;

type
  TFormAbout = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    lab_ProgramNameVer: TLabel;
    lab_Autor: TLabel;
    lab_Mail: TLabel;
    lab_Sait: TLabel;
    SpeedButton1: TSpeedButton;

    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);

    procedure lab_ProgramNameVerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure lab_ProgramNameVerMouseLeave(Sender: TObject);
    procedure lab_ProgramNameVerMouseEnter(Sender: TObject);

    procedure lab_MailMouseEnter(Sender: TObject);
    procedure lab_MailMouseLeave(Sender: TObject);
    procedure lab_MailClick(Sender: TObject);

    procedure lab_SaitMouseEnter(Sender: TObject);
    procedure lab_SaitMouseLeave(Sender: TObject);
    procedure lab_SaitClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);


  end;

var
    FormAbout: TFormAbout;

    procedure AboutExecute;



implementation


{$R *.dfm}


//============================================================================== About
procedure AboutExecute;
begin

Application.CreateForm(TFormAbout, FormAbout);

FormAbout.lab_ProgramNameVer.Caption  :=  _Program_NVC;
FormAbout.lab_ProgramNameVer.Hint     :=  Application.ExeName;

FormAbout.lab_Mail.Caption  :=  _Program_MailAdres;
FormAbout.lab_Sait.Caption  :=  _Program_SaitAdres;


FormAbout.ShowModal;

{ . . . }

FormAbout.Free;

end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Form Move
procedure TFormAbout.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
Form_Movie(Self);
end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Esc = Close
procedure TFormAbout.FormKeyPress(Sender: TObject; var Key: Char);
begin
if Key = #27 then Close;
end;



//------------------------------------------------------------------------------ Close
procedure TFormAbout.SpeedButton1Click(Sender: TObject);
begin
Close;
end;





//------------------------------------------------------------------------------ name
procedure TFormAbout.lab_ProgramNameVerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
Form1.Act_Program_OpenInExplorer.Execute;
end;

procedure TFormAbout.lab_ProgramNameVerMouseEnter(Sender: TObject);
begin
lab_ProgramNameVer.Font.Color := clAqua;
lab_ProgramNameVer.Font.Style := lab_ProgramNameVer.Font.Style + [fsUnderline]
end;

procedure TFormAbout.lab_ProgramNameVerMouseLeave(Sender: TObject);
begin
lab_ProgramNameVer.Font.Color := $00B3B300;
lab_ProgramNameVer.Font.Style := lab_ProgramNameVer.Font.Style - [fsUnderline]
end;






//------------------------------------------------------------------------------ mail
procedure TFormAbout.lab_MailClick(Sender: TObject);
begin
Form1.Act_Program_Mail.Execute;
end;

procedure TFormAbout.lab_MailMouseEnter(Sender: TObject);
begin
Lab_Mail.Font.Color := clWhite;
//Lab_Mail.Font.Style := lab_ProgramVer.Font.Style + [fsUnderline]
end;

procedure TFormAbout.lab_MailMouseLeave(Sender: TObject);
begin
Lab_Mail.Font.Color := clSilver;
//Lab_Mail.Font.Style := lab_ProgramVer.Font.Style - [fsUnderline]
end;






//------------------------------------------------------------------------------ sait
procedure TFormAbout.lab_SaitClick(Sender: TObject);
begin
Form1.Act_Program_Sait.Execute;
end;

procedure TFormAbout.lab_SaitMouseEnter(Sender: TObject);
begin
lab_Sait.Font.Color := clWhite;
end;

procedure TFormAbout.lab_SaitMouseLeave(Sender: TObject);
begin
lab_Sait.Font.Color := clSilver;
end;










end.
