unit kuModul;
{
 2018.19
      :    !
:  
kuzduk@mail.ru
kuzduk.000webhostapp.com
}

interface

uses
  Windows, SysUtils, Grids, Classes, Controls, ComCtrls, Graphics, Variants,
  ComObj, StdCtrls, ShellApi, ShlObj, ActiveX, Dialogs, IniFiles, Forms, Buttons,
  ActnMenus, Messages, ActnList, Menus, GraphUtil,

  kuShell,
  kuY;

  type GridX = class(TStringGrid);



{$REGION '   Metods   '}

  
//Form
procedure Form_Movie(Form: TForm);
function  Form_iniLoad(Form: TForm; SectionName: string = ''; AutoSize: byte = 1): Boolean;
procedure Form_iniSave(Form: TForm; SectionName: string = '');
procedure Form_CopyParam(FormSource, FormTarget: TForm);
procedure Form_TLWH_Normalize(Form: TForm);
procedure Form_FullScreen(Form : TForm);


//Dia
function Dia_File_Open(Caption, Filter, InitialDir: String; var OutPath: String) : Boolean;
function Dia_File_Save2(Caption, Filter, InitialDir, Ext: String; var out_Path: String; var out_ExportType: integer) : Boolean; overload;
function Dia_File_Save2(Caption, Filter, InitialDir, Ext: String; var out_Path: String) : Boolean; overload;


//Grid
procedure Grid_ColsWidthsAuto(Grid: TStringGrid; FromCol, ToCol, min, max, add : Integer);
procedure Grid_Copy(SourseGrid, TargetGrid: TStringGrid; BeginRow: integer = 0);
procedure Grid_SetFocus(Grid: TStringGrid; c, r: integer);
procedure Grid_SetKaretPos(Grid: TStringGrid; StartPos, SelectLength: integer);
function  Grid_SelStart(Grid: TStringGrid): Integer;
function  Grid_SelLength(Grid: TStringGrid): Integer;
function  Grid_ToExcelU(Grid: TStringGrid; FileName: string): boolean;
procedure Grid_MoveRows(Grid: TStringGrid; FromIndex, Count, ToIndex: integer);
function  Grid_RowTop(Grid: TStringGrid; Row: integer): integer;
procedure Grid_DrawSelectRect(Grid: TStringGrid; ARow: integer);


//Str
function  Str_Random(StrLength: SmallInt; Nabor: string = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'): string;
function  Str_DeleteWordBack(Str: string; var KaretPos: integer): string;
function  Str_inNabor(const Str, Nabor: string): Boolean;
function  Str_Sub_Count(const str, substr: string): integer;
function  Str_Sub_Delete(const Str, Sub: string): string;
function  Str_Sub_Change(const Str, Sub, New : string): string;
function  Str_Sub_PrePost(str, sub: string; Pre: boolean = True; FindNext: boolean = True): string;
procedure Str_Filter_Right(var Str: string; Symbol: Char);
procedure Str_Filter_Left (var Str: string; Symbol: Char);
procedure Str_ToStrs(const Str, Delimiter: string; Strs: TStrings);
function  Str_AsNOD(const Str: string; var sLevel: Integer): string;
function  pos_z(substr, str: string): integer;
function  Str_Find_Prev(NeedStr, Str: string; Registr: Boolean; b_Start: integer; var out_b: integer): Boolean;
function  Str_Find_Next(const NeedStr, Str: string; Registr: Boolean; b_Start: integer; var out_b: integer): Boolean;
function  Str_Crypt(const Str: string; Deep: integer; var DecodeKey: integer): string;
function  Str_DeCrypt(const Str: string; Deep: integer; DecodeKey: integer): string;


//Strs
function  Strs_Unikal_Add(Strs: TStrings; UnikalStr: string): Boolean;
procedure Strs_Unikal_Insert(Strs: TStrings; index: integer; UnikalStr: string; MoveExistInIndex: Boolean = True);
procedure Strs_DeleteStrs(Strs: TStrings; FromIndex, Count: Integer);
procedure Strs_DeleteFromTo(Strs: TStrings; j1, j2: Integer);
procedure Strs_MoveStrs(Strs: TStrings; FromIndex, ToIndex, Count: Integer);
procedure Strs_CopyStrs(Sourse: TStrings; SourseFromIndex, SourseToIndex: Integer; Target: TStrings);
procedure Strs_CutStrs(Sourse: TStrings; SourseFromIndex, SourseToIndex: Integer; Target: TStrings);
procedure Strs_InsertStrs(Hto, Kuda : TStrings; GoIndex: Integer);
procedure Strs_ToNODs(NODs: TTreeNodes; Kuda: TTreeNode; Strs: Tstrings; jFrom, jTo:integer);
procedure Strs_Filter(Strs: TStrings);
function  Strs_Sub_Has(Strs: TStrings; Sub: string) : Boolean;
function  Strs_Find_Prev(NeedStr: string; Registr: Boolean; Strs: TStrings; j_Start, j_End, b_Start: integer; var out_j, out_b: integer) : Boolean;
function  Strs_Find_Next(NeedStr: string; Registr: Boolean; Strs: TStrings; j_Start, j_End, b_Start: integer; var out_j, out_b: integer) : Boolean;
function  Strs_ToStr(Strs: TStrings; Delimiter: string): string;
procedure HistoryListAdd(Strs: TStrings; const MaxCount: integer; Str: string);


//Strs ini
function  Str_ToIniNameValue(const Str: string; var Name, Value: string): Boolean;
function  Strs_NameIndex(const Name: string; Strs: TStrings): Integer;
function  Strs_Value(const Name: string; Strs: TStrings): string;
function  Strs_SectionNext(const Section: string; Strs: TStrings): integer;
procedure Strs_SectionAllValues(const Section: string; Strs: TStrings; var outListAllValues: TStrings);
function  Strs_SectionClear(const Section: string; Strs: TStrings): integer;
procedure Strs_SectionDelete(const Section: string; Strs: TStrings);
procedure Strs_SectionsList(Strs: TStrings; var List: TStrings);
procedure Strs_AddNameValue(const Name, Value, Section: string; Strs: TStrings; CreateSection: Boolean = True);
procedure Strs_LoadSectionFromIni(var Strs: TStrings; SectionName, iniPath: string);
procedure Strs_SaveSectionToIni(Strs: TStrings; SectionName, iniPath: string; AutoCreateIni: Boolean = False);


//NOD
function NOD_Path(NOD: TTreeNode): string;
function NOD_to_Str(NOD: TTreeNode) : string;
function NOD_to_Strs(const NOD: TTreeNode) : TStrings;


//NODs
function  NODs_To_Strs(NODs: TTreeNodes) : TStrings;
procedure NODs_FindText(NODs: TTreeNodes; NeedText: string);


//Data
function  Dir_New(const FullPath: string): Boolean;
function  Dir_NewForce(Dir: string): Boolean;
function  Dir_Copy(SourceDir, TargetDir: string; StopIfNotAllCopied, OverWriteFiles: Boolean): Boolean;
function  Dir_Delete(YourDir : string): Boolean;
function  Dir_Rename(DirFullPath, NewFolName: string): string;
function  Dir_HasData(const Dir: string) : Boolean;
function  Dir_Foldered(const KatPath: string): string;

function  File_NameOnly(FullPath: string) : string;
function  File_ExtOnly(FullPath: string) : string;
function  File_Create(FullPath: string; Text: string = ''): Boolean;
function  File_NameUnikal(Dir, FileNameExt: string) : string;
function  File_Size(FilePath: string): Integer;
function  DataSizeFormat(const ASize: Int64): string;

function  Lnk_Test(Path: string; var LnkLinkPath: string): Boolean;
function  Lnk_GetPath(Path: string): string;
procedure Lnk_Create(const FilePath, LnkDir: string; Desc: string = ''; Param: string = '');

function FilesShellOperations(const Source, Target: string; Operacia: Integer; Flags: Integer = FOF_SIMPLEPROGRESS): Boolean; overload;
function FilesShellOperations(const Source: TStrings; const Target: string; Operacia: Integer; Flags: Integer = FOF_SIMPLEPROGRESS): Boolean; overload;


//Path
function Path_RelativToFull(Path: string; Tag: string = ''; TagValue: string =''): string;
function Path_FullToApp(const FullPath: string): string;
function Path_IsIn(SubPath, Path: string; var PostPath: string): Boolean;
function Path_DirUp(const Path: string; var CuttedFolName: string): string; overload;
function Path_DirUp(const Path: string): string; overload;
function Patch_GetIt(CSIDL: integer): string;
function Path_Desktop: string;
function Path_Win: string;
function Path_Sys: string;
function Path_App: string;


//Items
procedure Items_SelectInvers(Items: TListItems);
function  Items_Find(Items: TListItems; Str: string): TListItem;


//Font
procedure Font_iniLoad(ini: TiniFile; iniSection, iniParametr: string; FontX: TFont);
procedure Font_iniSave(ini: TiniFile; iniSection, iniParametr: string; FontX: TFont);
function Font_Width(Text: string; Font: TFont): integer;
function Font_Height(Text: string; Font: TFont): integer;


//List
procedure List_MultiSelect(List: TListBox; NewRow, OldRow: integer; Button: TMouseButton);
procedure List_SelectInvers(List: TListBox);
procedure List_DeselectAll(List: TListBox);
function  List_SmartSelectAfterDeleteOne(RowSelected, ListCount: integer; minResult: integer = -1): integer;


//Key
function KeyDownly(Key: integer): Boolean;
function CtrlDown : Boolean;
function ShiftDown : Boolean;
function AltDown : Boolean;


//Color
function cl_Darker(Color: TColor; Percent: Byte): TColor;
function cl_Lighter(Color: TColor; Percent: Byte): TColor;
function cl_Darker2(Color: TColor; Percent: Byte): TColor;
function cl_Lighter2(Color: TColor; Percent: Byte): TColor;
function ColorToHtml(const Color: Integer): AnsiString;


//Int
function RandomInt(min, max: integer) : integer;
function isEvent(YourInt: integer): Boolean;


//Rect
function PointInRect(Point: TPoint; Rect: TRect): boolean;
function ComponentRect(MyComponent: TWinControl): TRect;


//Aver
procedure btnColorDrawRect(Btn: TBitBtn; iColor: integer; RectWitdh: integer = -1);
function ResizeSplitProcent(Procent, Min: integer; Area: integer): integer;
procedure chb_AutoSize(chb: TCheckBox);
procedure MM_Widths(MM: TActionMainMenuBar);
procedure Draw_Rect(Canvas: TCanvas; p1, p2: TPoint; Color: TColor = clRed; Width: integer = 1);
function HintWithHotKey(Act: TAction; Dot: Boolean = False): string; overload;
function HintWithHotKey(MenuItem: TMenuItem; Dot: Boolean = False): string; overload;

//function HintingBkt(Act: TAction): string; override;
//function HintingBkt(Text: string): string; override;


{$ENDREGION}



const

AZ = #13#10;
_AppDirTeg = '%exe';
_kuKomponentsPaletteKategory = 'kuKomponents ;)';
_kuSait = 'http://kuzduk.000webhostapp.com';
_kuMail = 'kuzduk@mail.ru';
_setini = 'settings.ini';


{$REGION '   Colors   '}

cl_None :TColor    = -1 ;

cl_Red: Tcolor = $009797F2;


{  Okras  }
cl_Okrasn :TColor = $353000    ;
cl_Orozov :TColor = $11000     ;
cl_Oohren :TColor = $180800    ;
cl_Obiruz :TColor = $10133     ;
cl_Osiren :TColor = $10900     ;
cl_Ozelen :TColor = $100010    ;
cl_Osinen :TColor = $001A0700  ;
cl_Oboran :TColor = $535000    ;


{  grays:  }
cl_3  : TColor = $FAFAFA  ;
cl_5  : TColor = $F3F3F3  ;
cl_10 : TColor = $E6E6E6  ;
cl_15 : TColor = $D9D9D9  ;
cl_20 : TColor = $CCCCCC  ;
//cl_25 :TColor = 'Silver'   ;
cl_30 : TColor = $B3B3B3  ;
cl_35 : TColor = $A6A6A6  ;
cl_40 : TColor = $999999  ;
cl_45 : TColor = $8C8C8C  ;
//cl_50 :TColor = Gray     ;
cl_60 : TColor = $666666  ;
cl_70 : TColor = $4C4C4C  ;




{  HTML grays:  }
cl_html_grey15 :string = '#D9D9D9'  ;
cl_html_grey30 :string = '#B3B3B3'  ;




{$ENDREGION}





implementation



   
{$REGION '   Form   '}



//============================================================================== Movie
procedure Form_Movie(Form: TForm);
//uses Windows, Messages, Forms, Controls
//   .     MouseDown
begin

if Form.WindowState = wsMaximized then exit;

Screen.Cursor := crSizeAll;

ReleaseCapture;
Form.Perform(WM_SYSCOMMAND, $F012, 0);

Screen.Cursor := crDefault;

end;



//============================================================================== ini Load
function Form_iniLoad(Form: TForm; SectionName: string = ''; AutoSize: byte = 1): Boolean;
//   ini :  XY       WH
//   :  IDE    WindowsState = wsNormal
//AutoSize -  - WH  - XY,    ini     ini
//1 -       , 2 -   
var
  ini: TIniFile;
  iniPath: string;
  d: TWindowPlacement;

begin

Result := False;

if SectionName = '' then SectionName := Form.Name;

iniPath := ExtractFilePath(Application.ExeName) + _setini;

if FileExists(iniPath)
then
begin
  ini := TiniFile.Create(iniPath);
  try
        if ini.SectionExists(SectionName)
        then
        begin
              Form.Position := poDesigned;

              Form.Top     := ini.ReadInteger( SectionName, 'Top'    , 100 );
              Form.Left    := ini.ReadInteger( SectionName, 'Left'   , 100 );
              Form.Height  := ini.ReadInteger( SectionName, 'Height' , Form.Height );
              Form.Width   := ini.ReadInteger( SectionName, 'Width'  , Form.Width );

              Form_TLWH_Normalize(Form);

              if ini.ReadBool(SectionName, 'Maximized', False)
              then Form.WindowState := wsMaximized;
  //            else Form.WindowState := wsNormal;

              Result := True;
        end;

  finally
        ini.Free;
  end;
end;



// -  -    ini     ini
if Result = False
then
begin
  case AutoSize
  of
      1://    
      begin
        Form.Position := poScreenCenter;
        Form.WindowState := wsNormal;
        Form_TLWH_Normalize(Form);
      end;

      2://  +     
      begin
        Form.Position := poScreenCenter;
        Form_TLWH_Normalize(Form);

        GetWindowPlacement(Form.Handle, @d);

        d.rcNormalPosition.Top    := Form.Top;
        d.rcNormalPosition.Left   := Form.Left;
        d.rcNormalPosition.Bottom := Form.Top  + Form.Height;
        d.rcNormalPosition.Right  := Form.Left + Form.Width;

        Form.WindowState := wsMaximized;
      end;
  end;
end;


end;



//============================================================================== ini Save
procedure Form_iniSave(Form: TForm; SectionName: string);
//   ini :       
var
ini : TIniFile;
d: TWindowPlacement;
begin

if SectionName = '' then SectionName := Form.Name;

ini := TiniFile.Create( Path_App + _setini );

try
    ini.WriteBool( SectionName, 'Maximized', Form.WindowState = wsMaximized );


    GetWindowPlacement(Form.Handle, @d);

    ini.WriteInteger( SectionName, 'Top'    , d.rcNormalPosition.Top    );
    ini.WriteInteger( SectionName, 'Left'   , d.rcNormalPosition.Left   );
    ini.WriteInteger( SectionName, 'Height' , d.rcNormalPosition.Bottom - d.rcNormalPosition.Top   );
    ini.WriteInteger( SectionName, 'Width'  , d.rcNormalPosition.Right  - d.rcNormalPosition.Left  );

//    if Form.WindowState = wsNormal
//    then
//    begin
//        ini.WriteInteger( SectionName, 'Top'    , Form.Top    );
//        ini.WriteInteger( SectionName, 'Left'   , Form.Left   );
//        ini.WriteInteger( SectionName, 'Height' , Form.Height );
//        ini.WriteInteger( SectionName, 'Width'  , Form.Width  );
//    end;

finally
      ini.Free;
end;

end;



//============================================================================== TLWH Normalize
procedure Form_TLWH_Normalize(Form: TForm);
//     :
begin

//      ,    :
if Form.Height > Screen.Height then Form.Height := Screen.Height;
if Form.Width  > Screen.Width  then Form.Width  := Screen.Width ;

//      ,    :
if Form.Top  > Screen.Height - Form.Height then Form.Top  := Screen.Height - Form.Height;
if Form.Top  < 0 then Form.Top := 0;

if Form.Left > Screen.Width  - Form.Width then Form.Left := Screen.Width - Form.Width;
if Form.Left < 0 then Form.Left := 0;

end;



//============================================================================== Full Screen
procedure Form_FullScreen(Form : TForm);
begin

case Form.BorderStyle
of

  bsNone:
      Form.BorderStyle := bsSizeable;


  bsSizeable:
      begin
          Form.BorderStyle := bsNone;

          case Form.WindowState
          of
            wsNormal: Form.WindowState := wsMaximized;

            wsMaximized:
            begin
               Form.WindowState := wsNormal;
               Form.WindowState := wsMaximized;
            end;
          end;
      end;

end;

end;



//============================================================================== Copy Param
procedure Form_CopyParam(FormSource, FormTarget: TForm);
// :        .
//  Vizible := True     WinowState     
//   :    OnShow,     ?
var
wTarget, wSource: TWindowPlacement;

begin

GetWindowPlacement(FormSource.Handle, @wSource);
GetWindowPlacement(FormTarget.Handle, @wTarget);

FormTarget.Position := poDesigned;


case FormSource.WindowState
of



{$REGION '  norm '}
    wsNormal:
    begin
//        yy(' norm ');

        case FormTarget.WindowState
        of

            wsNormal:
            begin
                FormTarget.Top    := FormSource.Top;
                FormTarget.Left   := FormSource.Left;
                FormTarget.Height := FormSource.Height;
                FormTarget.Width  := FormSource.Width;

                exit;
            end;


            wsMaximized:
            begin
                FormTarget.WindowState := wsNormal;
//                yy('        Visible = False?     OnShow');

                FormTarget.Top    := FormSource.Top;
                FormTarget.Left   := FormSource.Left;
                FormTarget.Height := FormSource.Height;
                FormTarget.Width  := FormSource.Width;

                exit;
            end;

        end;

    end;
{$ENDREGION}




{$REGION '  max '}
  wsMaximized:
  begin
//    yy(' max');

    case FormTarget.WindowState
    of

        wsNormal:
        begin
            FormTarget.Top    := wSource.rcNormalPosition.Top;
            FormTarget.Left   := wSource.rcNormalPosition.Left;
            FormTarget.Height := wSource.rcNormalPosition.Bottom - wSource.rcNormalPosition.Top;
            FormTarget.Width  := wSource.rcNormalPosition.Right  - wSource.rcNormalPosition.Left;

            FormTarget.WindowState := wsMaximized;

            exit;
        end;


        wsMaximized:
        begin
            FormTarget.WindowState := wsNormal;

            FormTarget.Top    := wSource.rcNormalPosition.Top;
            FormTarget.Left   := wSource.rcNormalPosition.Left;
            FormTarget.Height := wSource.rcNormalPosition.Bottom - wSource.rcNormalPosition.Top;
            FormTarget.Width  := wSource.rcNormalPosition.Right  - wSource.rcNormalPosition.Left;

            //    
//            wTarget.rcNormalPosition := wSource.rcNormalPosition;
////
//            wTarget.rcNormalPosition.Top    := wSource.rcNormalPosition.Top;
//            wTarget.rcNormalPosition.Left   := wSource.rcNormalPosition.Left;
//            wTarget.rcNormalPosition.Bottom := wSource.rcNormalPosition.Bottom;
//            wTarget.rcNormalPosition.Right  := wSource.rcNormalPosition.Right;

            FormTarget.WindowState := wsMaximized;

            exit;
        end;

    end;

  end;
{$ENDREGION}



end;

//    
//  wTarget.rcNormalPosition := wSource.rcNormalPosition;
//  wTarget.rcNormalPosition.Top    := wSource.rcNormalPosition.Top;
//  wTarget.rcNormalPosition.Left   := wSource.rcNormalPosition.Left;
//  wTarget.rcNormalPosition.Bottom := wSource.rcNormalPosition.Bottom;
//  wTarget.rcNormalPosition.Right  := wSource.rcNormalPosition.Right;

//  wTarget.rcNormalPosition.Top    := FormSource.Top;
//  wTarget.rcNormalPosition.Left   := FormSource.Left;
//  wTarget.rcNormalPosition.Bottom := FormSource.Top  + FormSource.Height;
//  wTarget.rcNormalPosition.Right  := FormSource.Left + FormSource.Width;

//  FormTarget.Top    := FormSource.Top;
//  FormTarget.Left   := FormSource.Left;
//  FormTarget.Height := FormSource.Height;
//  FormTarget.Width  := FormSource.Width;

//  FormTarget.Top    := wSource.rcNormalPosition.Top;
//  FormTarget.Left   := wSource.rcNormalPosition.Left;
//  FormTarget.Height := wSource.rcNormalPosition.Bottom - wSource.rcNormalPosition.Top;
//  FormTarget.Width  := wSource.rcNormalPosition.Right  - wSource.rcNormalPosition.Left;

//  PostMessage(FormTarget.Handle, WM_MaximizeWindow , 0, 0);
//  SetWindowPlacement(FormTarget.Handle, @wTarget);
//      ShowWindowAsync (FormTarget.Handle, SW_NORMAL);

end;




{$ENDREGION}





{$REGION                          '   Str   '}


//------------------------------------------------------------------------------ Random Str
function Str_Random(StrLength: SmallInt; Nabor: string = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'): string;
var
  i: smallInt;
  s: string;

begin

for i := 1 to StrLength
do s := s + Nabor[RandomInt(1, Length(Nabor))]; //uses System.Math;


Result := s;

end;


//------------------------------------------------------------------------------
function Str_DeleteWordBack(Str: string; var KaretPos: integer): string;
var i, le: integer;

begin

Result := Str;

if str = '' then exit;

if KaretPos = 0 then exit;

le := Length(str);

if KaretPos = 1
then
begin
  Result := copy(Str, 2, le);
  exit;
end;


for i := KaretPos - 1 downto 1
do
begin

  if Str_inNabor(Str[i], '\|/ .')

  then
  begin
      if i = 1

      then Result := ''

      else
      begin
          Result := copy(Str, 1, i - 1) + copy(str, Karetpos +1, le );
          KaretPos := i;
      end;

      exit;
  end
end;

Result := '' ;

end;



//------------------------------------------------------------------------------ in Nabor
function Str_inNabor(const Str, Nabor: string): Boolean;
//     Str   Nabor
var
b, l: integer;


begin

l := Length(Str);

for b := 1 to l
do
begin
      if pos(Str[b], Nabor) = 0
      then
      begin
          Result := False;
          exit;
      end;
end;

Result := True;
  
  
end;



//------------------------------------------------------------------------------ pos 1
function pos1(SubStr, Str: string; Start: integer; Registr: Boolean): Boolean;
//  SubStr  Str    Start
//     Path_IsIn:
//pos1 -      Path_IsIn
// Path_IsIn     ..     PathPost
var le_str, le_substr: integer;
begin

Result := False;

if SubStr = '' then exit;

le_str    := Length(str);
le_substr := Length(substr);

if le_str < le_substr then exit;

str := copy(str, Start, le_substr);

if not Registr
then
begin
    str    := AnsiUpperCase(str);
    substr := AnsiUpperCase(substr)
end;

if str = substr then Result := True;

end;


//------------------------------------------------------------------------------ Sub Count
function Str_Sub_Count(const str, substr: string): integer;
//     
var
cnt, p, L: integer;
s : string;

begin

s := str;
cnt := 0;
L :=  Length(substr) - 1;

while true
do
begin

  p := Pos(substr, s);

  if p > 0

  then
  begin
    inc(cnt);
    Delete(s, 1, (p + L));
  end

  else
  begin
    Result := cnt;
    exit;
  end;


end;



end;


//------------------------------------------------------------------------------ Sub Delete
function Str_Sub_Delete(const Str, Sub: string): string;
//     
var
t : string;
p, L : Integer;
    
begin
  
t := Str;
p := pos(Sub, t);
L := Length(Sub);
  
while p > 0
do
begin
      Delete(t, p, L);
      p := pos(Sub, t);
end;
  
Result := t;

// :
//Resulr := StringReplace(t, _Lng_RedLine_Delimiter, #13#10, [rfReplaceAll]); //uses SysUtils
  
end;


//------------------------------------------------------------------------------ Sub Change
function Str_Sub_Change(const Str, Sub, New : string): string;
//    Sub    New
var
t : string;
p, L : Integer;
    
begin
  
t := Str;
L := Length(Sub);
p := pos(Sub, t);
  
while p > 0
do
begin
      Delete(t, p, L);
      Insert(New, t, p);
      p := pos(Sub, t);
end;
  
Result := t;
  
end;


//------------------------------------------------------------------------------ Filter Left
procedure Str_Filter_Left(var Str: string; Symbol: Char);
//        
begin

if Str = '' then exit;

//  1  
while (  Length(Str) > 0  )
  and (  AnsiUpperCase(Str[1]) = AnsiUpperCase(Symbol)  )
   do Delete( Str, 1, 1 );
  
end;

  
//------------------------------------------------------------------------------ Filter Right
procedure Str_Filter_Right(var Str: string; Symbol: Char);
//        
begin
  
if Str = '' then exit;
  
//  Symbol   
while (  Length(Str) > 0  )
  and (  AnsiUpperCase( Str[Length(Str)] ) = AnsiUpperCase(Symbol)  )
   do Delete( Str, Length(Str), 1 );

end;


//------------------------------------------------------------------------------ To Strs
procedure Str_ToStrs(const Str, Delimiter: string; Strs: TStrings);
//      
var
D, DD : integer;
    t : string;
  
begin
  
DD := Length(Delimiter);
t  := Str;
  
Strs.BeginUpdate;
Strs.Clear;
  
while True
     do
     begin
  
      D := pos(Delimiter, t) - 1;
        
      if D = -1
        then
        begin
            D := Length(t);
            Strs.Append( Copy(t, 1, D) );
            Delete(t, 1, D + DD);
            Break;
        end;
  
      Strs.Append( Copy(t, 1, D) );
      Delete(t, 1, D + DD);
  
     end;
  
Strs.EndUpdate;
  
  
end;


//------------------------------------------------------------------------------ As NOD
function Str_AsNOD(const Str: string; var sLevel: Integer): string;
//   
//  ""
var
  t : string;
  L : Integer;
  
begin
  
t := Str;
L := 0;
  
while t[1] = #9
do
begin
      Delete(t, 1, 1);
      L := L + 1;
end;
  
Result := t;
sLevel := L;
  
end;


//------------------------------------------------------------------------------ pos z <---
function pos_z(substr, str: string): integer;
{
  pos     : - <---
      .
 str - --->    1

:
str = 123456789
  
sub = 234
res = 2
  
sub = 7
res = 7
}
var
i: integer;
s: string;
  
begin
Result := 0;


if substr = '' then exit;

if Length(substr) > Length(str) then exit;

  
for i := Length(str) - Length(substr) + 1 downto 1
do
begin
      s := copy( str, i, Length(substr) );
//      y(substr, s);
  
      if  s = substr
      then
      begin
            Result := i;
//            y('',inttostr(i));
            exit;
      end;
end;
  
  
  
end;



//------------------------------------------------------------------------------ Find Next --->
function Str_Find_Next(const NeedStr, Str: string; Registr: Boolean; b_Start: integer; var out_b: integer): Boolean;
{
       --->
b_Start -     Str     (      1)
out_b -         str    NeedStr

   pos ,    b_Start     
}

var
s : string;
i : integer;

begin
  
Result := False;
  
if b_Start < 1
then
begin
      yy('Str_Find_Next' +#13#10+ 'b_Start   >= 1');
      exit;
end;

s := copy( Str, b_Start, Length(Str) );

if Registr = True
then i := pos( NeedStr, s )
else i := pos( AnsiUpperCase(NeedStr), AnsiUpperCase(s) );
  
if i = 0 then exit;

out_b := b_Start + i - 1;    
Result := True;

end;


//------------------------------------------------------------------------------ Find Prev <---
function Str_Find_Prev(NeedStr, Str: string; Registr: Boolean; b_Start: integer; var out_b: integer): Boolean;
{
       <---
b_Start -     Str     (      1)
 b_Start = -1       
out_b -         str    NeedStr

   pos: 1)   , 2)   b_Start, 3)   
}

var
b: integer;
s: string;
  
begin
Result := False;

if b_Start = 0 then exit;

//yy( '==='+str+'/'+ inttostr(Length(Str)) );
//yy('6~~Str_Find_Prev~~'+inttostr(b_start));

if b_Start > Length(str) then b_Start := Length(str);

if b_Start = -1
then s := Str
else s := copy(Str, 1, b_Start);

//yy('7~~Str_Find_Prev~~ '+s);


if Registr
then b := pos_z( NeedStr, s )
else b := pos_z( AnsiUpperCase(NeedStr), AnsiUpperCase(s) );

if b = 0 then exit;

out_b := b;
Result := True;
end;
  


//------------------------------------------------------------------------------ Sub PrePost
function Str_Sub_PrePost(str, sub: string; Pre: boolean = True; FindNext: boolean = True): string;
//       sub
//: Str_Sub_PrePost('1234567890', '34') = '12'
//Pre = true  -  ().
//Pre = false -  ().

var
  i, Last: integer;

begin
Result := '';


if FindNext
then i := pos(sub, str)    // - --->
else i := pos_z(sub, str); // - <---


if i <> 0
then
begin

    if Pre

    then
    begin
        if i > 1
        then Result := copy(str, 1, i - 1);
    end

    else
    begin
        Last := i + Length(Sub) - 1;

        if Last < Length(Str)
        then Result := copy(str, Last + 1, Length(Str));
    end;
end;


end;





//------------------------------------------------------------------------------ Crypt
function Str_Crypt(const Str: string; Deep: integer; var DecodeKey: integer): string;
var
  ChangeB, NextB, i, j, b, b2, a, L  :integer;
  NewStr: string;
  First: Boolean;
  t: Char;

begin

//ShowMessage( Memo1.Lines.Text[17] );


NextB := 3;
ChangeB := 4;
First := True;
b := 1;
b2 := 1;
L := length(Str);
NewStr := Str;


for i := 1 to Deep
do
begin

  ChangeB := ChangeB + 1;

    for j := 1 to L
    do
    begin
         while b > L
         do b := b - L;

         DecodeKey := b;

         b2 := b + ChangeB;

         while  b2 > L
         do b2 := b2 - L;

      //     ShowMessage(inttostr(L) +#10#13+  inttostr(b) +#10#13+ inttostr(b2) ) ;

         t := NewStr[b2];
         NewStr[b2] := NewStr[b];
         NewStr[b] := t;
         b := b + NextB;
    end;

end;




Result := NewStr;

end;



//------------------------------------------------------------------------------ DeCrypt
function Str_DeCrypt(const Str: string; Deep: integer; DecodeKey: integer): string;
var
  ProhodovFull, ChangeB, NextB, i, j, b, b2, a, L  :integer;
  NewStr: string;
  First: Boolean;
  t: Char;

begin

//ShowMessage( Memo1.Lines.Text[17] );


NextB := 3;
ChangeB := 4 + Deep;
First := True;
b := DecodeKey;
b2 := 1;
L := length(Str);
NewStr := Str;


for i := Deep downto 1
do
begin

  for j := 1 to L
  do
  begin
     while b < 1
     do b := b + L;

     b2 := b + ChangeB;
     while b2 > L
     do b2 := b2 - L;

//     ShowMessage(inttostr(L) +#10#13+  inttostr(b) +#10#13+ inttostr(b2) ) ;

     t := NewStr[b2];
     NewStr[b2] := NewStr[b];
     NewStr[b] := t;
     b := b - NextB;
  end;

  ChangeB := ChangeB - 1;
end;

Result := NewStr;

end;




{$ENDREGION}





{$REGION                              '   Strs   '}




{$REGION '   Unikal   '}


//============================================================================== Add
function Strs_Unikal_Add(Strs: TStrings; UnikalStr: string): Boolean;
//  .        false    .
var j, b: integer;
begin

Result := False;

if Strs.IndexOf(UnikalStr) = -1
then
begin
    Strs.Append(UnikalStr);
    Result := True;
end;

end;


//============================================================================== Insert
procedure Strs_Unikal_Insert(Strs: TStrings; index: integer; UnikalStr: string; MoveExistInIndex: Boolean = True);
//  .
var
j: Integer;


begin


j := Strs.IndexOf(UnikalStr);

if j = -1

then//    
begin
    Strs.Insert(index, UnikalStr);
end

else//    
begin
    if j = index

    then //Strs[j] := UnikalStr

    else
    begin
//        Strs.Delete(j);
//        Strs.Insert(0, UnikalStr);
        if MoveExistInIndex
        then Strs.Move(j, 0);
    end;
end;


end;


{$ENDREGION}





{$REGION '   Strs Strs   '}



//============================================================================== Strs Delete FromTo
procedure Strs_DeleteFromTo(Strs: TStrings; j1, j2: Integer);
//    
var i, Index, Count : Integer;

begin

if j1 > Strs.Count - 1
then
begin
    Showmessage('Strs_DeleteFromTo' +#13#10+ 'j1 > Strs.Count - 1');
    exit;
end;

if j2 > Strs.Count - 1
then
begin
    Showmessage('Strs_DeleteFromTo' +#13#10+ 'j2 > Strs.Count - 1');
    exit;
end;


if j1 = j2
then
begin
  Count := 1;
  Index := j1;
end

else
begin
    if j1 > j2

    then
    begin
      Count := j1 - j2 + 1;
      Index := j2;
    end

    else
    begin
      Count := j2 - j1 + 1;
      Index := j1;
    end;
end;


for i := 1 to Count
do Strs.Delete(Index);


end;


//============================================================================== Strs Delete Strs
procedure Strs_DeleteStrs(Strs: TStrings; FromIndex, Count: Integer);
//    
var i: Integer;

begin


if FromIndex < 0
then
begin
    Showmessage('Strs_DeleteStrs' +#13#10+ 'FromIndex < 0');
    exit;
end;


if FromIndex > Strs.Count - 1
then
begin
    Showmessage('Strs_DeleteStrs' +#13#10+ 'FromIndex > Strs.Count - 1');
    exit;
end;


if Count > Strs.Count - FromIndex
then
begin
    Showmessage('Strs_DeleteStrs' +#13#10+ 'Count > Strs.Count - FromIndex');
    exit;
end;


//if FromIndex = -1
//
//then//    
//    for i := 1 to Count
//    do Strs.Delete(Strs.Count - 1)
//
//else//  FromIndex
    for i := 1 to Count
    do Strs.Delete(FromIndex);

end;


//============================================================================== Strs Move Strs
procedure Strs_MoveStrs(Strs: TStrings; FromIndex, ToIndex, Count: Integer);
//    
var i : Integer;

begin

if FromIndex = ToIndex then exit;


if ToIndex < FromIndex

then {  }
begin
    FromIndex := FromIndex + Count - 1; //   
    for i := 1 to Count
    do Strs.Move(FromIndex, ToIndex);

//    for i := 0 to Count - 1
//    do
//    begin
//         Strs.Insert( ToIndex + i, Strs[FromIndex + i] );
//         Strs.Delete( FromIndex + i );
//    end;
end

else {  }
begin
    ToIndex := ToIndex - 1; // -1  ToIndex  ???
    for i := 1 to Count
    do Strs.Move(FromIndex, ToIndex) ;
end



end;


//============================================================================== Strs CopyStrs
procedure Strs_CopyStrs(Sourse: TStrings; SourseFromIndex, SourseToIndex: Integer; Target: TStrings);
//        
var i : Integer;
begin


if SourseFromIndex < SourseToIndex

then//:  
begin
      for i := SourseFromIndex to SourseToIndex
      do Target.Append( Sourse[i] );
end

else//   !
begin
      for i := SourseFromIndex downto SourseToIndex
      do Target.Append( Sourse[i] );
end;


end;



//============================================================================== Strs CutStrs
procedure Strs_CutStrs(Sourse: TStrings; SourseFromIndex, SourseToIndex: Integer; Target: TStrings);
begin

Strs_CopyStrs        (Sourse, SourseFromIndex, SourseToIndex, Target);
Strs_DeleteFromTo    (Sourse, SourseFromIndex, SourseToIndex        );

end;



//============================================================================== Strs InsertStrs
procedure Strs_InsertStrs(Hto, Kuda: TStrings; GoIndex: Integer);
//    
var
  i : Integer;

begin

if Hto = nil then exit;
if Kuda = nil then exit;

for I := Hto.Count - 1 downto 0
  do Kuda.Insert(GoIndex, Hto.Strings[i]);

end;



{$ENDREGION}





{$REGION '   Find   '}



//============================================================================== Sub Has
function Strs_Sub_Has(Strs: TStrings; Sub: String): Boolean;
// true     
var i, ii : Integer;
begin

Result := False;

ii := Strs.Count - 1;

for i := 0  to ii
do
begin

        if pos(Sub, Strs.Strings[i]) <> 0
        then
        begin
           Result := True;
           exit;
        end;

end;

end;


//============================================================================== Strs Find Next --->
function Strs_Find_Next(NeedStr: string; Registr: Boolean; Strs: TStrings; j_Start, j_End, b_Start: integer; var out_j, out_b: integer): Boolean;
{
      

j_Start -    ()
j_End   -   ()
b_Start -     ()
       1
}
var
j, n: integer;

begin
Result := False;

for j := j_Start to j_End
do
begin
        if Str_Find_Next(NeedStr, Strs.Strings[j], Registr, b_Start, n)
        then
        begin
              out_j := j;
              out_b := n;

              Result := True;
              exit;
        end;

        b_Start := 1; //    ,     

end;

end;


//============================================================================== Strs Find Prev <---
function Strs_Find_Prev(NeedStr: string; Registr: Boolean; Strs: TStrings; j_Start, j_End, b_Start: integer; var out_j, out_b: integer): Boolean;
{
   :    

j_Start -    () if -1 then     Strs
j_End   -   ()
b_Start -     ()  if -1 then       
       1
}
var
j, b : integer;

begin
Result := False;


if j_Start = -1 then j_Start := Strs.Count - 1;
//yy('3~~ '+Strs.Text);
for j := j_Start downto j_End
do
begin
//        yy('4~~'+Strs.Text+'======'+inttostr(b_Start) );
        //yy(Strs[j]);

        if Str_Find_Prev(NeedStr, Strs[j], Registr, b_Start, b)
        then
        begin
              out_j := j;
              out_b := b;

              Result := True;
              exit;
        end;

        b_Start := -1; //   ,     
end;

end;


{$ENDREGION}





//============================================================================== Strs Filter
procedure Strs_Filter(Strs: TStrings);
var
i: Integer;
s: String;

begin

for i := Strs.Count - 1 downto 0
do
begin

      s := Strs.Strings[i];

      //1.   
      Str_Filter_Right(s, ' ');

      //2.      
      if (s = '') and (i = Strs.Count - 1)
      then Strs.Delete(i)
      else Strs.Strings[i] := s;

//      //1.   
//      Str_Filter_Right(Strs[i], ' ');
//
//      //2.      
//      if (Strs[i] = '') and (i = Strs.Count - 1)
//      then Strs.Delete(i);

end;

end;



//============================================================================== Strs to NODs
procedure Strs_ToNODs(NODs: TTreeNodes; Kuda: TTreeNode; Strs: Tstrings; jFrom, jTo:integer);
//    
var
  ZNode, NextNode: TTreeNode;
  L, KudaLevel, i: Integer;
  t: string;

begin
NODs.BeginUpdate;

if Kuda = nil
then KudaLevel := -1
else KudaLevel := Kuda.Level;

ZNode := Kuda;

for i := jFrom to jTo
do
begin

      t := Str_AsNOD(Strs.Strings[i], L);
      L := L + KudaLevel + 1;

      if L = 0
      then ZNode := NODs.Add(nil, t)
      else
          if L = KudaLevel
          then ZNode := NODs.AddChild(Kuda, t)
          else
                if L = ZNode.Level
                then ZNode := NODs.Add(ZNode, t)
                else
                      if (L - 1) = ZNode.Level
                      then ZNode := NODs.AddChild(ZNode, t)
                      else
                            if L < ZNode.Level
                            then
                            begin
                                  NextNode := ZNode.Parent;

                                  while NextNode.Level > L
                                  do NextNode := NextNode.Parent;

                                  ZNode := NODs.AddChild(NextNode.Parent, t);
                            end;
end;

NODs.EndUpdate;
end;



//============================================================================== Strs to Str
function Strs_ToStr(Strs: TStrings; Delimiter: string): string;
var i: integer;

begin

Result := Strs[0];

if Strs.Count = 1 then exit;

for i := 1 to Strs.Count - 1
do Result := Result + Delimiter + Strs[i];

end;



//============================================================================== HistoryListAdd
procedure HistoryListAdd(Strs: TStrings; const MaxCount: integer; Str: string);
//         MaxCount
begin

Strs_Unikal_Insert(Strs, 0, str);

if Strs.Count > MaxCount
then Strs_DeleteFromTo(Strs, Strs.Count - 1, MaxCount);
//Strs_DeleteStrs(Strs, -1, Strs.Count - MaxCount);

end;



{$ENDREGION}





{$REGION '   Strs ini   '}



//============================================================================== Str to Name=Value
function Str_ToIniNameValue(const Str: string; var Name, Value: string): Boolean;
var
i: integer;
iName, iValue: string;

begin

i := AnsiPos('=', Str);

if i <> 0

then
begin
    iName  := copy(Str, 1, i - 1);
    iValue := copy(Str, i + 1, length(Str));
    Str_Filter_Right(iName, ' ');
    Str_Filter_Right(iName, #9);
    Name  := iName;
    Value := iValue;
    Result := True;
end

else Result := False;


end;


//============================================================================== Name Index
function Strs_NameIndex(const Name: string; Strs: TStrings): Integer;
var
  i, P: Integer;
  S, iName, iValue: string;

begin

for i := 0 to Strs.Count - 1
do
begin
  S := Strs[i];

  if Str_ToIniNameValue(S, iName, iValue)
  then
  begin
      if AnsiCompareText(iName, Name) = 0
      then
      begin
          Result := i;
          exit;
      end;
  end;
end;

Result := -1;

end;


//============================================================================== Value
function Strs_Value(const Name: string; Strs: TStrings): string;
var
  i: Integer;
  s: string;

begin

  i := Strs_NameIndex(Name, Strs);

  if i = -1
  then Result := ''
  else
  begin
     s := Strs[i];
     Result := Copy(s, AnsiPos('=', s) + 1, Length(s));
  end;

end;


//============================================================================== Add Name Value
procedure Strs_AddNameValue(const Name, Value, Section: string; Strs: TStrings; CreateSection: Boolean = True);
// Name=Value
// Name   -   ,      Name=Value
var
i, j, FirstEmptyStr: integer;
s, iName, iValue: string;
FindEmptyStr: Boolean;

label jLast;

begin

j := Strs.IndexOf('[' + Section + ']');

if j = -1
then
begin
    Strs.Append('[' + Section + ']');
    j := Strs.Count - 1;
end;

if j = Strs.Count - 1

then
begin
    Strs.Append(Name+'='+Value);
end

else
begin
  j := j + 1;
  FirstEmptyStr := -1;
  FindEmptyStr := True;

  for i := j to Strs.Count - 1
  do
  begin
      S := Strs[i];

      //   !


      //   
      if s = ''
      then
      begin
//        yy('  ' + s);
        if FindEmptyStr then FirstEmptyStr := i;
        FindEmptyStr := False;
        if i = Strs.Count - 1 then goto jLast;
        Continue;
      end;

      FindEmptyStr := True;

      //    
      Str_ToIniNameValue(s, iName, iValue);

      if (AnsiUpperCase(s) = AnsiUpperCase(Name)) or (AnsiUpperCase(iName) = AnsiUpperCase(Name))
      then
      begin
//          yy('   ' + s);
          Strs[i] := Name+'='+Value;
          exit;
      end;

//      else yy(' ,   '+s);



      //  
      if length(s) > 2
      then
      begin
          if ( (Strs[i][1] = '[') and (Strs[i][Length(Strs[i])] = ']') )
          then
          begin
//              yy(' ' + s);
              if FirstEmptyStr <> -1
              then Strs.Insert(FirstEmptyStr, Name +'='+ Value)
              else Strs.Insert(i, Name +'='+ Value);
              exit;
          end;
      end;


      //   
      if i = Strs.Count - 1
      then
      begin
           jLast:
//           yy('  ' + s);
           if FirstEmptyStr <> -1
           then Strs.Insert(FirstEmptyStr, Name +'='+ Value)
           else Strs.Append(Name +'='+ Value); // append
           exit;
      end;

  end;
end;


end;





{$REGION ' Section '}


//============================================================================== Section All Values
procedure Strs_SectionAllValues(const Section: string; Strs: TStrings; var outListAllValues: TStrings);
var
s, i, n: integer;

begin

n := Strs_SectionNext(Section, Strs);

case n
of

    -1: exit;

    -2: exit;

    -3: begin
          s := Strs.IndexOf('[' + Section + ']');
          for i := s + 1 to Strs.Count - 1
          do outListAllValues.Append(Strs[i]);
        end;

    else
        begin
          s := Strs.IndexOf('[' + Section + ']');
          if s = n - 1 then exit; //   
          for i := s + 1 to n - 1
          do outListAllValues.Append(Strs[i]);
        end;

end;


end;


//============================================================================== Section Next
function Strs_SectionNext(const Section: string; Strs: TStrings): integer;
// j  
// -1 =>     , ,   .
// -2 =>   ,  -   
// -3 =>   ,  -  C 

var
 i, j: integer;
 s: string;


begin

j := Strs.IndexOf('[' + Section + ']');


/////-1
if j = -1
then
begin
    //    , ,   .
    Result := -1;
    exit;
end;


/////-2
if j = Strs.Count - 1
then
begin
   // -    ,   .
   Result := -2;
   exit;
end;


/////-3
//  :
j := j + 1;

for i := j to Strs.Count - 1
do
begin
    s := Strs[i];

    if length(s) > 2
    then
        if ( s[1] = '[' ) and ( s[Length(s)] = ']' )
        then
        begin
          Result := i;
          exit;
        end;
end;


//  ,  -    , 
Result := -3;


end;


//============================================================================== Section Clear
function Strs_SectionClear(const Section: string; Strs: TStrings): integer;
// j  
var jCurrentSection, jNextSection: integer;

begin

jCurrentSection := Strs.IndexOf('[' + Section + ']');


if jCurrentSection = -1
then
begin
    Result := -1;
    exit;
end;


jNextSection := Strs_SectionNext(Section, Strs);

case jNextSection
of

  -2://  
  begin
     Result := Strs.Count - 1;
  end;

  -3://  
  begin
    Strs_DeleteFromTo(Strs, jCurrentSection + 1, Strs.Count - 1);
    Result := jCurrentSection;
  end;

  else// 
  begin
    Strs_DeleteFromTo(Strs, jCurrentSection + 1, jNextSection - 1);
    Result := jCurrentSection;
  end;

end;



//j := Strs.IndexOf('[' + Section + ']');
//
//Result := j;
//
//if j = -1 then exit;
//if j = Strs.Count - 1 then exit;
//
//j := j + 1;
//
//for i := j to Strs.Count - 1
//do
//begin
//    if length(Strs[j]) < 3
//    then Strs.Delete(j)
//    else
//        if ( Strs[j][1] = '[' ) and ( Strs[j][Length(Strs[j])] = ']' )
//        then exit
//        else Strs.Delete(j);
//end;


end;


//============================================================================== Section Delete
procedure Strs_SectionDelete(const Section: string; Strs: TStrings);
var j: integer;

begin

j := Strs_SectionClear(Section, Strs);

if j <> -1 then Strs.Delete(j);

end;


//============================================================================== Sections List
procedure Strs_SectionsList(Strs: TStrings; var List: TStrings);
var
  i, j, l: Integer;

begin

List.Clear;

for i := 0 to Strs.Count - 1
do
begin

  if Strs[i][1] = '['
  then
  begin
      l := length(Strs[i]);
      if Strs[i][l] = ']'
      then List.Append(copy(strs[i], 2, l - 2));
  end;

end;

end;


{$ENDREGION}





{$REGION ' Strs ~ ini '}



//==============================================================================
procedure Strs_LoadSectionFromIni(var Strs: TStrings; SectionName, iniPath: string);
var
  ini, tStrs : TStrings;
  i, j: integer;


begin


if not FileExists(iniPath) then exit;

tStrs := TStringList.Create;
ini := TStringList.Create;
ini.LoadFromFile(iniPath);
j := Strs_SectionNext(SectionName, ini);

case j
of
   -1: exit;
   -2: exit;
   -3:  //..
   else //..
end;

Strs_SectionAllValues(SectionName, ini, tStrs);
Strs_Filter(tStrs);

Strs.Assign(tStrs);

ini.Free;
tStrs.Free;

end;


//==============================================================================
procedure Strs_SaveSectionToIni(Strs: TStrings; SectionName, iniPath: string; AutoCreateIni: Boolean = False);
var
  ini: TStrings;

begin



if FileExists(iniPath)

then
begin
  ini := TStringList.Create;
  ini.LoadFromFile(iniPath);
end

else
begin
      if AutoCreateIni

      then
      begin
        ini          := TStringList.Create;
        ini.Text     := ANSItoUTF8(ini.Text);
        ini.WriteBOM := True;
      end

      else exit;
end;


if Strs.Count = 0
then
begin
  Strs_SectionClear(SectionName, ini);
end

else
begin
  Strs_Filter(Strs);

  Strs_SectionDelete(SectionName, ini);
  ini.Append('[' + SectionName + ']');
  Strs_CopyStrs(Strs, 0, Strs.Count - 1, ini);
end;


ini.SaveToFile(iniPath);

ini.Free;


//ini := TiniFile.Create(iniPath);
//try
//
//      if ini.SectionExists(SectionName)
//      then ini.EraseSection(SectionName);
//
//
//      for i := 0 to Strs.Count - 1
//      do ini.WriteString(SectionName, inttostr(i), Strs[i]);
//
//finally
//      ini.Free;
//end;

end;



{$ENDREGION}





{$ENDREGION}





{$REGION                       '   NOD   '}
  
  
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> NOD Path
function NOD_Path(NOD: TTreeNode): string;
//   
begin
  
Result := '';
  
if NOD = nil then exit;
  
while NOD <> nil
do
begin
    Result := NOD.Text + '\' + Result;
    NOD := NOD.Parent;
end;
  
Delete(Result, Length(Result), 1);
  
end;
  
  
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> NOD to Str
function NOD_to_Str(NOD: TTreeNode) : String;
//     .  =      
var
 i: Integer;
 Tabs : string;
  
begin
  
Tabs := '';
  
for i := 1 to NOD.Level
   do Tabs := Tabs + #9;
  
Result := Tabs + NOD.Text;
  
end;
  
  
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> NOD to Strs
function NOD_to_Strs(const NOD: TTreeNode) : TStrings;
//      
var
  iNod : TTreeNode;
  L : Integer;
  t : string;
  StrLst : TStrings;

begin

StrLst := TStringList.Create;
iNod := NOD;
L := NOD.Level;

//NextNod := NOD.getNextSibling;
//while NextNod <> iNod

while iNod <> NOD.getNextSibling
   do
   begin
      t := NOD_To_Str(iNod);
      Delete(t, 1, L);
      StrLst.Append( t );
      iNod := iNod.getNext;
   end;
  
Result := StrLst;
  
end;


{$ENDREGION}





{$REGION                         '   NODs   '}
  
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< NODs to Strs
function NODs_to_Strs(NODs: TTreeNodes): TStrings;
//   

var
  L, i : Integer;
  t : string;
  Strs : TStrings;
  
begin
  
Strs := TStringList.Create;
L := 0;
  
for I := 0 to NODs.Count-1
   do
   begin
      t := NOD_To_Str( NODS.Item[i] );
      Delete( t, 1, L );
      Strs.Append( t );
   end;
  
Result := Strs;
  
end;
  
  
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< NODs Find Text
procedure NODs_FindText(NODs: TTreeNodes; NeedText: string);
//  
var
  Noddy: TTreeNode;
  Searching: Boolean;
  
begin
  
Noddy := NODs[0];
Searching := true;
  
while (Searching = True) and (Noddy <> nil)
  do
  begin
  
          if Noddy.text = NeedText
  
            then
            begin
                Searching := False;
                NODs.Owner.Deselect(NODs.Owner.Selected);
                NODs.Owner.Selected := Noddy;
                NODs.Owner.SetFocus;
            end
  
            else
            begin
                Noddy := Noddy.GetNext
            end;
  
  end;
  
end;


{$ENDREGION}





{$REGION '   Data   '}




{$REGION ' Dir '}
  

  
//------------------------------------------------------------------------------ New
function Dir_New(const FullPath: String) : Boolean;
//       
begin
  
Result := false;
  
if not DirectoryExists(FullPath)
then
begin
  
    if CreateDir(FullPath) = False
    then
    begin
//        Y_('', 'Cannot create dir' + AZ + FullPath);
        exit;
    end;
  
end;
  
Result := true;
  
end;


//------------------------------------------------------------------------------ New Force
function Dir_NewForce(Dir: string): Boolean;
// ForceDirectories
var
  i, L: Integer;
  CurDir: string;

begin

if ExcludeTrailingBackslash(Dir) = '' then exit;

Dir := IncludeTrailingBackslash(Dir);
L := Length(Dir);

for i := 1 to L
do
begin
  CurDir := CurDir + Dir[I];

  if Dir[i] = '\'
  then
  begin
    if not DirectoryExists(CurDir) then
      if not CreateDir(CurDir) then exit;
  end;
end;

Result := True;

end;


//------------------------------------------------------------------------------ Copy
function Dir_Copy(SourceDir, TargetDir: string; StopIfNotAllCopied, OverWriteFiles: Boolean): Boolean;
//    :   
var
  SR: TSearchRec;
  I: Integer;

begin

Result := False;

SourceDir := IncludeTrailingBackslash(SourceDir);
TargetDir := IncludeTrailingBackslash(TargetDir);

if not DirectoryExists(SourceDir)  then Exit;
if not ForceDirectories(TargetDir) then Exit;

I := FindFirst(SourceDir + '*', faAnyFile, SR);
try
  while I = 0 do
  begin

    if (SR.Name <> '') and (SR.Name <> '.') and (SR.Name <> '..')
    then
    begin
      if SR.Attr = faDirectory
      then Result := Dir_Copy(SourceDir + SR.Name, TargetDir + SR.NAME, StopIfNotAllCopied, OverWriteFiles)
      else if not (not OverWriteFiles and FileExists(TargetDir + SR.Name))
            then Result := CopyFile(Pchar(SourceDir + SR.Name), Pchar(TargetDir + SR.Name), False)
            else Result := True;

      if not Result and StopIfNotAllCopied then exit;
    end;

    I := FindNext(SR);
  end;

finally
  SysUtils.FindClose(SR);
end;

end;



//------------------------------------------------------------------------------ Delete
function Dir_Delete(YourDir : string) : Boolean;
//    :   
var
  iIndex: Integer;
  SearchRec: TSearchRec;
  sFileName: string;
    
begin

Result := False;
YourDir := YourDir + '\*.*';
iIndex := FindFirst(YourDir, faAnyFile, SearchRec);
    
while iIndex = 0
do
begin
    
    sFileName := ExtractFileDir(YourDir) +'\'+ SearchRec.name;

    if SearchRec.Attr = faDirectory
    
    then
    begin
      if (SearchRec.name <> '' ) and (SearchRec.name <> '.') and (SearchRec.name <> '..')
      then Dir_Delete(sFileName);
    end
    
    else
    begin
        if SearchRec.Attr <> faArchive
        then FileSetAttr(sFileName, faArchive);
    
        if not DeleteFile(sFileName)
        then Dir_Delete('Can NOT delete :(' + sFileName);
    end;
    
    iIndex := FindNext(SearchRec);
    
end;
    
FindClose(SearchRec);
RemoveDir(ExtractFileDir(YourDir));
Result := True;

    
end;


//------------------------------------------------------------------------------ Rename
function Dir_Rename(DirFullPath, NewFolName: string) : string;
// 
var
  NewFullPath, t: string;
    
begin
  
Result := '';
  
NewFullPath := Path_DirUp(DirFullPath, t) +'\'+ NewFolName;
RenameFile(DirFullPath, NewFullPath);
  
Result := NewFullPath;
  
end;


//------------------------------------------------------------------------------ Has Data
function Dir_HasData(const Dir: string) : Boolean;
//     
var
  Telo : TSearchRec;
  MyDir : string;
  
begin

Result := false;
  
MyDir := IncludeTrailingBackslash(Dir);
  

if FindFirst(MyDir + '*.*', faAnyFile, Telo) = 0
then
begin
    repeat
            if Telo.Name    = '.'     then Continue;
            if Telo.Name    = '..'    then Continue;
  
//            y_('Dir_HasData', '   :'+AZ+ Dir +AZ + Telo.Name);
            Result := true;
            FindClose(Telo);
            exit;

    until FindNext(Telo) <> 0;
end;

FindClose(Telo);
  

  
end;


//------------------------------------------------------------------------------ Foldered
function Dir_Foldered(const KatPath: string): string;
//         .kat
var NewDir: string;

begin

NewDir := ExtractFilePath(KatPath) + File_NameOnly(KatPath);
ForceDirectories(NewDir);
Result := NewDir + '\' + ExtractFileName(KatPath);

end;

  
{$ENDREGION}




{$REGION ' File '}
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Name + ext
function File_Name(const FullPath: string): string;
//       + 
// ExtractFileName

var
t, s : string;
i, l : integer;
  
begin
  
t := FullPath;
l := Length(t);
  
if (FullPath[l] = '\') or (FullPath[l] = '/')
then Delete(t, l, 1);
  
s := ExtractFileName(FullPath);
i := Length(s) - Length( ExtractFileExt(s) );
Result := Copy(s, 1, i)
    
end;
  
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Name Only
function File_NameOnly(FullPath: string) : string;
//          
var
s : string;
i : integer;
    
begin
    
s := ExtractFileName(FullPath);
i := Length(s) - Length( ExtractFileExt(s) );
Result := Copy(s, 1, i)
    
end;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Name Unikal
function File_NameUnikal(Dir, FileNameExt: string) : string;
//    FullPath
var
    i: Integer;
    FullPath, iName, fName, fExt: string;

begin

fExt := ExtractFileExt(FileNameExt);
fName := File_NameOnly(FileNameExt);

i := 2;
FullPath := IncludeTrailingBackSlash(Dir) + FileNameExt;


while FileExists(FullPath)
do
begin
    iName := fName + ' ('+ inttostr(i) +')';
    FullPath := IncludeTrailingBackSlash(Dir) + iName + fExt;
    i := i + 1;
end;

Result := FullPath;


end;


//------------------------------------------------------------------------------ File_Name_Correctly
function File_Name_Correctly(NameLength: integer) : string;
//
var
i, x: integer;
Arr_A : array [0..35] of string[1];

begin

Arr_A[0]  := '/';
Arr_A[1]  := '\';
Arr_A[2]  := '|';
Arr_A[3]  := '?';
Arr_A[4]  := ':';
Arr_A[5]  := '*';
Arr_A[6]  := '"';
Arr_A[7]  := '<';
Arr_A[8]  := '>';


Randomize;

for i := 1 to NameLength
do
begin
   x := Random(35);
   Result := Result + Arr_A[x];
end;



end;
    
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Ext Only
function File_ExtOnly(FullPath: string) : string;
//          
var
s : string;
    
begin
    
s := ExtractFileExt(FullPath);
if (s <> '') and (s <> '.')
then Result := Copy( s, 2, Length(s) )
else Result := '';
    
    
end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Create
function File_Create(FullPath: string; Text: string = '') : Boolean;
//   
var List : TStringList;
  
begin
Result := False;
  
List         := TStringList.Create;
List.Sorted  := False;
List.Text    := Text;
List.SaveToFile(FullPath);
List.Free;
  
if FileExists(FullPath) then Result := true;
  
  
end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ File Size
function File_Size(FilePath: string): Integer;
var
InfoFile: TSearchRec;
AttrFile: Integer;
ErrorReturn: Integer;

begin

AttrFile := $0000003F; {Any file}
ErrorReturn := FindFirst(FilePath, AttrFile, InfoFile);

if ErrorReturn <> 0
then Result := -1 { ,    }
else Result := InfoFile.Size; {   }

FindClose(InfoFile);

end;



{$ENDREGION}




{$REGION ' Lnk '}



//------------------------------------------------------------------------------ Lnk test
function  Lnk_Test(Path: string; var LnkLinkPath: string): Boolean;
var ext: string;

begin
Result := false;

ext := AnsiLowerCase( File_ExtOnly(Path) );

if ext <> '.lnk' then exit;

Path := Lnk_GetPath(Path);

if FileExists(Path)

then
begin
  Result := True;
  LnkLinkPath := Path;
end

else
begin
   yy('    :' + #13#10 + Path);
   exit;
end;


end;



//------------------------------------------------------------------------------ Lnk get Path
function Lnk_GetPath(Path: string): string;
//      
var
  MyObject: IUnknown;
  MySLink: IShellLink;
  MyPFile: IPersistFile;
  FileInfo: TWin32FINDDATA;
  WidePath: array[0..MAX_PATH] of WideChar;
  Buff: array[0..MAX_PATH] of Char;

begin

Result := '';
if (FileExists(Path) = false) then exit;
MyObject := CreateComObject(CLSID_ShellLink);
MyPFile := MyObject as IPersistFile;
MySLink := MyObject as IShellLink;
StringToWideChar(Path, WidePath, SizeOf(WidePath));
MyPFile.Load(WidePath, STGM_READ);
MySLink.GetPath(Buff, Max_PATH, FileInfo, SLGP_UNCPRIORITY);
Result := buff;

end;



//------------------------------------------------------------------------------ Lnk get Path
procedure Lnk_Create(const FilePath, LnkDir: string; Desc: string = ''; Param: string = '');
var
  IObject: IUnknown;
  SLink: IShellLink;
  PFile: IPersistFile;
  LnkPath: string;

begin
  IObject := CreateComObject(CLSID_ShellLink);
  SLink := IObject as IShellLink;
  PFile := IObject as IPersistFile;

  with SLink do
  begin
    SetArguments(PChar(Param));
    SetDescription(PChar(Desc));
    SetPath(PChar(FilePath));
  end;

  LnkPath :=  IncludeTrailingBackslash(LnkDir) + File_NameOnly(FilePath) + '.lnk';
  PFile.Save( PWChar(WideString(LnkPath) ), false);
end;




{$ENDREGION}




{$REGION ' Files Shell Operations '}
//  ///      Shell API
{
uses ShellAPI

Source - . c      .     Clipboard_SpecStr
Target - .         

Operacia:
FO_COPY
FO_MOVE
FO_RENAME
FO_DELETE

Flags:
FOF_ALLOWUNDO         -  ,     UnDo.       ,     ,    /
FOF_CONFIRMMOUSE      -  .
FOF_FILESONLY         -    pFrom  *.*,       .
FOF_MULTIDESTFILES    - ,        pFrom    - .
FOF_NOCONFIRMATION    -  "yes to all"      .
FOF_NOCONFIRMMKDIR    -     ,   ,    .
FOF_RENAMEONCOLLISION -    :       ,          "Copy #N of..."
FOF_SILENT            -      .
FOF_SIMPLEPROGRESS    -     ,     .
FOF_WANTMAPPINGHANDLE -  hNameMappings .      SHFreeNameMappings
}


//------------------------------------------------------------------------------ Data Operations #
function FilesShellOperations___(const SourceSpecStr, Target: string; Operacia, Flags: Integer): Boolean;


var SHOS: TSHFileOpStruct;

begin

//FillChar (SHOS, SizeOf(SHOS), #0);
//ZeroMemory(@SHOS, SizeOf(SHOS));

SHOS.Wnd    := 0;
SHOS.wFunc  := Operacia;
SHOS.pFrom  := PChar(SourceSpecStr);
SHOS.pTo    := PChar(Target);
SHOS.fFlags := Flags;

Result := (SHFileOperation(SHOS) = 0) and (not SHOS.fAnyOperationsAborted);

end;



//------------------------------------------------------------------------------ Data Operations Str
function FilesShellOperations(const Source, Target: string; Operacia: Integer; Flags: Integer = FOF_SIMPLEPROGRESS): Boolean; overload;
var SourceSpecStr: string;

begin

SourceSpecStr := ShellSpecStr(Source);

Result := FilesShellOperations___(SourceSpecStr, Target, Operacia, Flags);

end;



//------------------------------------------------------------------------------ Data Operations Strs
function FilesShellOperations(const Source: TStrings; const Target: string; Operacia: Integer; Flags: Integer = FOF_SIMPLEPROGRESS): Boolean; overload;
var SourceSpecStr: string;

begin

SourceSpecStr := ShellSpecStr(Source);

Result := FilesShellOperations___(SourceSpecStr, Target, Operacia, Flags);

end;



{$ENDREGION}




//------------------------------------------------------------------------------
procedure Dat_Find(FolderPath, NeedStr: string; RegistrSensitiv: Boolean);
var
 sr: TSearchRec;
 FileName: String;

begin

FolderPath := IncludeTrailingBackSlash(FolderPath);

//if FindFirst(Folder + '*.*', faAnyFile, sr) = 0
//then  //  
//begin
//
//  repeat
//      if (sr.Name='.') or (sr.Name='..') then continue;
//
//      if (sr.Attr and faDirectory) = faDirectory
//      then //   
//      begin
//        Dat_Find(FileName); {      .
//                                   -       
//                                    }
//        Continue;
//      end;
//
//  //    if AnsiUpperCase(EdLookFor.Text) = AnsiUpperCase(sr.Name)
//  //    then //    
//  //     Memo1.Lines.Add(FileName); //    .     ,    Memo1
//
//     until FindNext(sr) <> 0; //       
//
//  FindClose(sr);
//
//end;

end;


//------------------------------------------------------------------------------ File Size Format
function DataSizeFormat(const ASize: Int64): string;
begin

if ASize < 1024
  then Result := IntToStr(ASize) + ' byte'
  else if ASize < 1048576
//         then Result := FloatToStrF(ASize / 1024, ffFixed, 15, 0) + ' Kb'
         then
         begin
            Result := FloatToStrF(ASize / 1048576, ffFixed, 15, 1) + ' Mb';
            if Result = '0,0 Mb' then Result := '0,1 Mb'
         end

         else  if ASize < 1073741824
               then Result := FloatToStrF(ASize / 1048576, ffFixed, 15, 0) + ' Mb'
               else Result := FloatToStrF(ASize / 1073741824, ffFixed, 15, 1) + ' Gb';


//         FormatFloat("0.0", inttostr(sr.size) );
//         format('%10.1f',[sr.Size/1024/1024]) + ' Mb'
end;



{$ENDREGION}





{$REGION '   Path   '}



//------------------------------------------------------------------------------ Relativ to Full
function Path_RelativToFull(Path: string; Tag: string = ''; TagValue: string = ''): string;
{
    Path  .

*   :    Tag   TagValue        .

*         , : D ---> D:\

*    :
%exe -  
%ProgDir -     %exe

* %% WINDOWS
}

{$REGION ' %% windows -   '}
 {
  Environment Windows 7 x64

  %ALLUSERSPROFILE% = C:\ProgramData

  %APPDATA% = C:\Users\Name\AppData\Roaming

  %CommonProgramFiles% = C:\Program Files (x86)\Common Files

  %CommonProgramFiles(x86)% = C:\Program Files (x86)\Common Files

  %CommonProgramW6432% = C:\Program Files\Common Files

  %COMPUTERNAME% = Comp.Name

  %ComSpec% = C:\Windows\system32\cmd.exe

  %HOMEDRIVE% = C:

  %HOMEPATH% = \Users\Name

  %LOCALAPPDATA% = C:\Users\Name\AppData\Local

  %LOGONSERVER% = \\Comp.Name

  %OS% = Windows_NT

  %Path% = C:\Windows\system32;C:\Windows;C:\Windows\System32\Wbem;C:\Windows\System32\WindowsPowerShell\v1.0\ ()

  %PATHEXT% = .COM;.EXE;.BAT;.CMD;.VBS;.VBE;.JS;.JSE;.WSF;.WSH;.MSC ()

  %ProgramData% = C:\ProgramData

  %ProgramFiles% = C:\Program Files (x86)

  %ProgramFiles(x86)% = C:\Program Files (x86)

  %ProgramW6432% = C:\Program Files

  %PUBLIC% = C:\Users\Public

  %SystemDrive% = C:

  %SystemRoot% = C:\Windows

  %TEMP% = C:\Users\Name\AppData\Local\Temp ( )
  %TEMP% = %SystemDrive%\Temp  -
  [HKEY_CURRENT_USER\Environment]
  "TEMP"=hex(2):25,00,53,00,79,00,73,00,74,00,65,00,6d,00,44,00,72,00,69,00,76,\
  00,65,00,25,00,5c,00,54,00,65,00,6d,00,70,00,00,00

  %TMP% = C:\Users\Name\AppData\Local\Temp ( )
  %TMP% = %SystemDrive%\Temp  -
  [HKEY_CURRENT_USER\Environment]
  "TMP"=hex(2):25,00,53,00,79,00,73,00,74,00,65,00,6d,00,44,00,72,00,69,00,76,00,\
  65,00,25,00,5c,00,54,00,65,00,6d,00,70,00,00,00

  %USERDOMAIN% = Name Dom.

  %USERNAME% = Name

  %USERPROFILE% = C:\Users\Name

  %windir% = C:\Windows

    x86:  3   1

  %CommonProgramFiles% = C:\Program Files (x86)\Common Files
  %CommonProgramFiles(x86)% = C:\Program Files (x86)\Common Files \ %CommonProgramFiles% = C:\Program Files\Common Files
  %CommonProgramW6432% = C:\Program Files\Common Files

  

  %ProgramFiles% = C:\Program Files (x86)
  %ProgramFiles(x86)% = C:\Program Files (x86) / %ProgramFiles% = C:\Program Files
  %ProgramW6432% = C:\Program Files
  }
{$ENDREGION}


var
 s: string;
 i: integer;
 buf : array[0..$FF] of char;
 sSize : integer;


begin

Result := Path;

if Path = '' then exit;



{$REGION ' Tag <> " and TagValue <> " '}
//    s   %
// Tag  TagValue
if (Tag <> '') and (TagValue <> '')
then
begin
    if Path_isIn(Tag, Path, s)
    then
    begin
        TagValue := ExcludeTrailingBackSlash(TagValue);
        Result := TagValue + s;
    end;

    exit;
end;
{$ENDREGION}





{$REGION  ' C '}
if Length(Path) = 1
then
begin
//    if Path[1] in ["a".."z"] then
    Result := Path + ':';
    exit;
end;
{$ENDREGION}





{$REGION ' % '}
if Path[1] = '%'
then
begin

  if

  Path_IsIn(_AppDirTeg, Path, s)
  or
  Path_IsIn('%ProgDir', Path, s)

  then
  begin
      Result := ExcludeTrailingBackSlash(Path_App) + s;
  end

  else
  begin
      i := pos(PathDelim, Path);
      if i > 1
      then Tag := copy(Path, 1, i - 1)
      else Tag := Path;

      sSize := ExpandEnvironmentStrings( PChar(Tag), buf, sizeof(buf) );
      TagValue := copy(buf, 1, sSize);
      Result := Path_RelativToFull(Path, Tag, TagValue);
  end;

end;
{$ENDREGION}





end;



//------------------------------------------------------------------------------ Full to Prog
function Path_FullToApp(const FullPath: string) : string;
{
    .
  :
..   FullPath     ,         __PROG_DIR_TEG
}
begin

Result := Path_RelativToFull(  FullPath, Path_App, _AppDirTeg  );

end;



//------------------------------------------------------------------------------ Is In
function Path_IsIn(SubPath, Path: string; var PostPath: string): Boolean;
//  SubPath   Path?
var le_path, le_subPath, b: integer;
begin

Result := False;

if SubPath = '' then exit;

Path    := ExcludeTrailingBackslash(Path);
SubPath := ExcludeTrailingBackslash(SubPath);

le_path    := Length(Path);
le_subPath := Length(SubPath);

if le_path < le_subPath then exit;

if AnsiUpperCase( copy(Path, 1, le_subPath ) ) = AnsiUpperCase(SubPath)
then
begin
    Result := True;

    if le_path = le_subPath

    then
    begin
        PostPath := '';
    end

    else
    begin
        PostPath := copy(Path, le_subPath + 1, le_Path); //   subPath:      ...
//        if PostPath[1] <> PathDelim then PostPath := PathDelim + PostPath;
    end;
end;

end;





//------------------------------------------------------------------------------ Dir Up
function Path_DirUp(const Path: string; var CuttedFolName: string) : string; overload;
//    

var
p : integer;
t : string;

begin

t := Path;

if t[length(t)] = '\' then t := copy(t, 1, length(t) - 1);
//t := ExcludeTrailingBackslash(t);

p := pos_z('\', t);

if p = 0

then
begin
  Result := '';
  CuttedFolName := t;
end

else
begin
  Result := copy(t, 1, p - 1);
  CuttedFolName := Copy(t, p + 1, Length(t));
end;

end;

//------------------------------------------------------------------------------ Dir Up
function Path_DirUp(const Path: string) : string; overload;
var s: string;
begin

Path_DirUp(Path, s);

end;






//------------------------------------------------------------------------------ >>
function Patch_GetIt(CSIDL: integer): string;
//uses ActiveX, ShlObj;
//CSIDL_DESKTOP
//CSIDL_BITBUCKET	Recycle bin &frac34; file system directory containing file objects in the user"s recycle bin. The location of this directory is not in the registry; it is marked with the hidden and system attributes to prevent the user from moving or deleting it.
//CSIDL_CONTROLS	Control Panel &frac34; virtual folder containing icons for the control panel applications.
//CSIDL_DESKTOP	Windows desktop &frac34; virtual folder at the root of the name space.
//CSIDL_DESKTOPDIRECTORY	File system directory used to physically store file objects on the desktop (not to be confused with the desktop folder itself).
//CSIDL_DRIVES	My Computer &frac34; virtual folder containing everything on the local computer: storage devices, printers, and Control Panel. The folder may also contain mapped network drives.
//CSIDL_FONTS	Virtual folder containing fonts.
//CSIDL_NETHOOD	File system directory containing objects that appear in the network neighborhood.
//CSIDL_NETWORK	Network Neighborhood &frac34; virtual folder representing the top level of the network hierarchy.
//CSIDL_PERSONAL	File system directory that serves as a common respository for documents.
//CSIDL_PRINTERS	Printers folder &frac34; virtual folder containing installed printers.
//CSIDL_PROGRAMS	File system directory that contains the user"s program groups (which are also file system directories).
//CSIDL_RECENT	File system directory that contains the user"s most recently used documents.
//CSIDL_SENDTO	File system directory that contains Send To menu items.
//CSIDL_STARTMENU	File system directory containing Start menu items.
//CSIDL_STARTUP	File system directory that corresponds to the user"s Startup program group.
//CSIDL_TEMPLATES	File system directory that serves as a common repository for document templates.
var
  SpecialDir: PItemIdList;
begin
    SetLength(result, MAX_PATH);
    SHGetSpecialFolderLocation(Application.Handle, CSIDL, SpecialDir);
    SHGetPathFromIDList(SpecialDir, PChar(Result));
    SetLength(result, lStrLen(PChar(Result)));
end;


//------------------------------------------------------------------------------ >> Windows
function Path_Win: string;
//    Windows
begin

SetLength( result, 1024 );
SetLength( result, GetWindowsDirectory(PChar(result), 1024) );

end;


//------------------------------------------------------------------------------ >> System32
function Path_Sys: string;
//    system32
begin

SetLength( result, 1024 );
SetLength( result, GetSystemDirectory(PChar(result), 1024) );

end;


//------------------------------------------------------------------------------ >> Desktop
function Path_Desktop: string;
//uses ShlObj;
var
 PIDL: PItemIDList;
// Path: LPSTR;
  Path:PWideChar;
const

 CSIDL_DESKTOP = $0000;

begin

// Path := PAnsiChar( StrAlloc(MAX_PATH) );
 Path := StrAlloc(MAX_PATH) ;
 SHGetSpecialFolderLocation(Application.Handle, CSIDL_DESKTOP, PIDL);

 if SHGetPathFromIDList(PIDL, Path)
 then Result := Path
 else Result := '';
end;


//------------------------------------------------------------------------------ >> App
function Path_App: string;
//  ,     .
//  ,   : \
begin

Result := ExtractFilePath(Application.ExeName);

end;


//------------------------------------------------------------------------------ >> settings.ini
function Path_Setini: string;
begin

Result := Path_App + _setini;

end;



{$ENDREGION}





{$REGION     '   Font   '}




//------------------------------------------------------------------------------
procedure Font_iniLoad(ini: TiniFile; iniSection, iniParametr: string; FontX: TFont);
begin


if ini = nil then exit;


//Name
if ini.ValueExists(iniSection, iniParametr + '.Name')
then FontX.Name := ini.ReadString(iniSection, iniParametr + '.Name', FontX.Name);


//Size
if ini.ValueExists(iniSection, iniParametr + '.Size')
then FontX.Size := ini.ReadInteger(iniSection, iniParametr + '.Size', FontX.Size);


//Color
if ini.ValueExists(iniSection, iniParametr + '.Color')
then FontX.Color := StringToColor(   ini.ReadString( iniSection, iniParametr + '.Color', ColorToString(FontX.Color) )   );


//Bold
if ini.ValueExists(iniSection, iniParametr + '.Bold')
then
  if ini.ReadBool(iniSection, iniParametr + '.Bold', FontX.Style = FontX.Style + [fsBold])
  then FontX.Style := FontX.Style + [fsBold]
  else FontX.Style := FontX.Style - [fsBold];


//Italic
if ini.ValueExists(iniSection, iniParametr + '.Italic')
then
  if ini.ReadBool(iniSection,  iniParametr + '.Italic', FontX.Style = FontX.Style + [fsItalic])
  then FontX.Style := FontX.Style + [fsItalic]
  else FontX.Style := FontX.Style - [fsItalic];


//Uderlined
if ini.ValueExists(iniSection, iniParametr + '.Uderline')
then
  if ini.ReadBool(iniSection, iniParametr + '.Uderline', FontX.Style = FontX.Style + [fsUnderline])
  then FontX.Style := FontX.Style + [fsUnderline]
  else FontX.Style := FontX.Style - [fsUnderline];


//Strike
if ini.ValueExists(iniSection, iniParametr + '.Strike')
then
  if ini.ReadBool(iniSection, iniParametr + '.Strike', FontX.Style = FontX.Style + [fsStrikeOut])
  then FontX.Style := FontX.Style + [fsStrikeOut]
  else FontX.Style := FontX.Style - [fsStrikeOut];


end;



//------------------------------------------------------------------------------
procedure Font_iniSave(ini: TiniFile; iniSection, iniParametr: string; FontX: TFont);
begin

if ini = nil then exit;

ini.WriteString  ( iniSection, iniParametr + '.Name',    FontX.Name  );

ini.WriteInteger ( iniSection, iniParametr + '.Size',    FontX.Size  );

ini.WriteString  ( iniSection, iniParametr + '.Color',    ColorToString(FontX.Color) );

ini.WriteBool    ( iniSection, iniParametr + '.Bold',      FontX.Style = FontX.Style + [fsBold]      );
ini.WriteBool    ( iniSection, iniParametr + '.Italic',    FontX.Style = FontX.Style + [fsItalic]    );
ini.WriteBool    ( iniSection, iniParametr + '.Uderline',  FontX.Style = FontX.Style + [fsUnderline] );
ini.WriteBool    ( iniSection, iniParametr + '.Strike',    FontX.Style = FontX.Style + [fsStrikeOut] );

end;


//------------------------------------------------------------------------------
function Font_Width(Text: string; Font: TFont): integer;
var Bmp: TBitmap;

begin

Bmp := TBitmap.Create;

try
  Bmp.Canvas.Font.Assign(Font);
  Result := Bmp.Canvas.TextWidth(Text);

finally
  Bmp.Free;
end;

end;



//------------------------------------------------------------------------------
function Font_Height(Text: string; Font: TFont): integer;
var Bmp: TBitmap;

begin

Bmp := TBitmap.Create;

try
  Bmp.Canvas.Font.Assign(Font);
  Result := Bmp.Canvas.TextHeight(Text);

finally
  Bmp.Free;
end;

end;




{$ENDREGION}





{$REGION '   Items   '}
  



//------------------------------------------------------------------------------ Select Invers
procedure Items_SelectInvers(Items: TListItems);
var i: integer;
begin
  
for i := 0 to Items.Count - 1
do Items[i].Selected := not Items[i].Selected;

end;



  
//------------------------------------------------------------------------------ Find
function Items_Find(Items: TListItems; Str: string): TListItem;
//  ListView
var i : integer;
begin
  
Result := nil;
    
for i := 0 to Items.Count - 1
do
begin
      if Items[i].Caption = Str
      then
      begin
           Result := Items.Item[i];
           exit;
      end;      
end;
      
    
end;




{$ENDREGION}






{$REGION                            '   Dia   '}



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Open
function Dia_File_Open(Caption, Filter, InitialDir: String; var OutPath: String) : Boolean;
var Dia : TOpenDialog;

begin

Dia := TOpenDialog.Create(Application.MainForm);
Dia.InitialDir := InitialDir;
Dia.Title  := Caption;
Dia.Filter := Filter;
Dia.Execute;


if Dia.FileName = ''

then
begin
   Result := False;
end

else
begin
    Result := True;
    OutPath := Dia.FileName;
end;

//Dia.Destroy;
Dia.Free;

end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Save
function Dia_File_Save2(Caption, Filter, InitialDir, Ext: String; var out_Path: String; var out_ExportType: integer): Boolean; overload;
var Dia : TSaveDialog;

begin

Dia := TSaveDialog.Create(Application.MainForm);

Dia.Title      := Caption;
Dia.Filter     := Filter;
if InitialDir <> '' then Dia.InitialDir := InitialDir;
Dia.DefaultExt := Ext;
Dia.Execute;


if Dia.FileName = ''

then
begin
    Result := False;
end

else
begin
    Result := True;
    out_Path := Dia.FileName;
    out_ExportType := Dia.FilterIndex;
end;


Dia.Free;


end;




//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Save
function Dia_File_Save2(Caption, Filter, InitialDir, Ext: String; var out_Path: String): Boolean; overload;
var i: integer;
begin

Result := Dia_File_Save2(Caption, Filter, InitialDir, Ext, out_Path, i);

end;


{$ENDREGION}





{$REGION '   Grid   '}



//############################################################################## Cols Widths Auto
procedure Grid_ColsWidthsAuto(Grid: TStringGrid; FromCol, ToCol, min, max, add : Integer);
//     StringGrid     
//max = -1      
var i, w: integer;


      function Grid_ColWidthAuto1(Grid: TStringGrid; Col: integer) : integer;
      var i, t : integer;
      begin

          Result := 0;

          for i := 0 to Grid.RowCount - 1
          do
          begin
                t := Grid.Canvas.TextWidth( Grid.Cells[Col, i] );
                if t > Result
                then Result := t;
          end;

      end;



begin



for i := FromCol to ToCol
do
begin
      if (max = -1) and (min = -1)
      then
      begin
         Grid.ColWidths[i] := -1;
         Continue;
      end;

      w := Grid_ColWidthAuto1(Grid, i);

      if min > -1
        then if w < min then w := min;

      if max > -1
        then if w > max then w := max;

      Grid.ColWidths[i] := w + add;

end;


end;






//############################################################################## Set Focus
procedure Grid_SetFocus(Grid: TStringGrid; c, r: integer);
//   ---    StrinGris
var SRect: TGridRect;

begin with Grid do begin

    //    ,     .      ,   ,        
    Grid.RowCount := Grid.RowCount + 1;
    Grid.Row := RowCount - 1;



    SetFocus; {  }

    Row := r; { Row/Col}
    Col := c;

    SRect.Top := r; {  }
    SRect.Left := c;
    SRect.Bottom := r;
    SRect.Right := c;
//    Selection := SRect; { }


    //  
    Grid.RowCount := Grid.RowCount - 1;

end;end;



//############################################################################## Sel Length
function Grid_SelLength(Grid: TStringGrid): Integer;
//      Stringgrid
begin

Result := GridX(Grid).InplaceEditor.SelLength;

end;



//############################################################################## Sel Start
function Grid_SelStart(Grid: TStringGrid): Integer;
//     
begin

Result := GridX(Grid).InplaceEditor.SelStart;

end;



//############################################################################## Set Karet Pos
procedure Grid_SetKaretPos(Grid: TStringGrid; StartPos, SelectLength: integer);
// --        
begin

GridX(Grid).InplaceEditor.SelStart  := StartPos;
GridX(Grid).InplaceEditor.SelLength := SelectLength;

end;







//############################################################################## Copy
procedure Grid_Copy(SourseGrid, TargetGrid: TStringGrid; BeginRow: integer = 0);
//   StringGrid  
var i : integer;
begin

TargetGrid.ColCount := SourseGrid.ColCount;
TargetGrid.RowCount := SourseGrid.RowCount;

for i := BeginRow to SourseGrid.RowCount - 1
do TargetGrid.Rows[i].Assign(SourseGrid.Rows[i]);

end;



//############################################################################## Move Rows
procedure Grid_MoveRows(Grid: TStringGrid; FromIndex, Count, ToIndex: integer);
//     ToIndex   
var i : integer;
begin

if FromIndex = ToIndex then exit;


if ToIndex < FromIndex

then{  }
begin
    FromIndex := FromIndex + Count - 1;//   
    for i := 1 to Count
    do GridX(Grid).MoveRow(FromIndex, ToIndex);


end

else{  }
begin
    ToIndex := ToIndex - 1; // -1  ToIndex  ???
    for i := 1 to Count
    do GridX(Grid).MoveRow(FromIndex, ToIndex);
end;



end;






//############################################################################## as Explorer
procedure Grid_as_Explorer(Grid: TStringGrid; Dir: string);
// StringGrid   :    
var
  sr: TSearchRec;
  ShInfo: TSHFileInfo;
  r: integer;

begin

if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

if FindFirst(Dir + '*.*', faAnyFile + faDirectory + faVolumeId, sr) <> 0 then exit;

Grid.ColCount := 5; // 01 | ico | Name | Ext | Size
Grid.RowCount := 0;

repeat
      if sr.Name = ''   then Continue;
      if sr.Name = '.'  then Continue;
      if sr.Name = '..' then Continue;

      Grid.RowCount := Grid.RowCount + 1;

      SHGetFileInfo( PChar(Dir + sr.Name), 0, ShInfo, SizeOf(ShInfo), SHGFI_TYPENAME or SHGFI_SYSICONINDEX );

      if sr.Attr and faDirectory = faDirectory

      then//
      begin
          Grid.Cells[0, r] := '0';          //0
          Grid.Cells[1, r] := inttostr(ShInfo.iIcon); //ico
          Grid.Cells[2, r] := sr.Name;      //Name
          Grid.Cells[3, r] := 'dir';        //Ext
          Grid.Cells[4, r] := '---';        //Size
      end

      else//
      begin
          Grid.Cells[0, r] := '0';                     //0
          Grid.Cells[1, r] := inttostr(ShInfo.iIcon);  //ico
          Grid.Cells[2, r] := File_NameOnly(sr.Name);  //Name
          Grid.Cells[3, r] := File_ExtOnly(sr.Name);   //Ext
          Grid.Cells[4, r] := inttostr(sr.size);       //Size
      end;

      r := r + 1;

until FindNext(sr) <> 0;

FindClose(sr);

end;








//############################################################################## To Excel
function Grid_ToExcelU(Grid: TStringGrid; FileName: string): boolean;
const
  xlWBATWorksheet = -4167;

var
  Row, Col: Integer;
  GridPrevFile: string;
  XLApp, Sheet: OLEVariant;

begin

  Result := False;
  XLApp  := CreateOleObject('Excel.Application');
  try
    XLApp.Visible := False;
    XLApp.Workbooks.Add(xlWBatWorkSheet);
    Sheet      := XLApp.Workbooks[1].WorkSheets[1];
    Sheet.Name := 'My Sheet Name';
    for col := 0 to Grid.ColCount - 1 do
      for row := 0 to Grid.RowCount - 1 do
        Sheet.Cells[row + 1, col + 1] := Grid.Cells[col, row];
    try
      XLApp.Workbooks[1].SaveAs(FileName);
      Result := True;
    except
      // Error ?
    end;
  finally
    if not VarIsEmpty(XLApp) then
    begin
      XLApp.DisplayAlerts := False;
      XLApp.Quit;
      XLAPP := Unassigned;
      Sheet := Unassigned;
    end;
  end;

end;




//############################################################################## To Excel  OLE
procedure Grid_ToExcel_WithoutOLE(Grid: TStringGrid; AFileName: string);
// StringGrid  Ansi    OLE
const
   {$J+}
   CXlsBof: array[0..5] of Word = ($809, 8, 00, $10, 0, 0);
   {$J-}
   CXlsEof: array[0..1] of Word = ($0A, 00);

var
   FStream: TFileStream;
   i, j: Integer;


      procedure XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word; const AValue: string);
      var
         L: Word;

      const
         {$J+}
         CXlsLabel: array[0..5] of Word = ($204, 0, 0, 0, 0, 0);
         {$J-}

      begin

         L := Length(AValue);
         CXlsLabel[1] := 8 + L;
         CXlsLabel[2] := ARow;
         CXlsLabel[3] := ACol;
         CXlsLabel[5] := L;
         XlsStream.WriteBuffer( CXlsLabel, SizeOf(CXlsLabel) );
         XlsStream.WriteBuffer( Pointer(AValue)^, L );

      end;



begin

FStream := TFileStream.Create(PChar(AFileName), fmCreate or fmOpenWrite);

try

     CXlsBof[4] := 0;
     FStream.WriteBuffer(CXlsBof, SizeOf(CXlsBof));

     for i := 0 to Grid.ColCount - 1
     do
         for j := 0 to Grid.RowCount - 1
         do XlsWriteCellLabel(FStream, i, j, Grid.Cells[i, j]);

     FStream.WriteBuffer(CXlsEof, SizeOf(CXlsEof));

finally
     FStream.Free;
end;

end;









//############################################################################## RowTop
function Grid_RowTop(Grid: TStringGrid; Row: integer): integer;
// y-  Row
//      !!!
begin

Result :=

//  :
Grid.FixedRows * Grid.DefaultRowHeight + Grid.FixedRows +

//  :
(Row - Grid.TopRow) * Grid.DefaultRowHeight + (Row - Grid.TopRow);

end;



//############################################################################## Draw Select Rect
procedure Grid_DrawSelectRect(Grid: TStringGrid; ARow: integer);
// Row  
var RowTop: integer;
begin

Grid.Canvas.Pen.Width := 2;
Grid.Canvas.Pen.Color := clRed;

//   5 
RowTop := Grid_RowTop(Grid, ARow);

Grid.Canvas.Polyline
([
Point( 0,                   RowTop + 1 ),
Point( Grid.GridWidth - 1,  RowTop + 1 ),
Point( Grid.GridWidth - 1,  RowTop + Grid.DefaultRowHeight - 1),
Point( 1,                   RowTop + Grid.DefaultRowHeight - 1),
Point( 1,                   RowTop )
]);


end;




procedure Draw_Rect(Canvas: TCanvas; p1, p2: TPoint; Color: TColor = clRed; Width: integer = 1);
begin


Canvas.Pen.Width := Width;
Canvas.Pen.Color := Color;


//RowTop := Grid_RowTop(Grid, ARow);


//   5 
Canvas.Polyline
([
Point( P1.X + Width,                         P1.Y),
Point( P2.X - Width,             P1.Y),
Point( P2.X - Width + 1,             P2.Y - Width + 1),
Point( Width - 1,                    P2.Y - Width + 1),
Point( Width - 1,                    P1.Y )
]);



end;


{$ENDREGION}






{$REGION '   Key   '}



//------------------------------------------------------------------------------ Key Downly
function KeyDownly(Key: integer): Boolean;
//  ?
//Ctrl  = VK_Control
//Shift = VK_Shift
//Alt   = VK_MENU
var
  State : TKeyboardState;

begin

GetKeyboardState(State);
Result := ( (State[Key] and 128) <> 0 );

end;


//------------------------------------------------------------------------------ Ctrl
function CtrlDown : Boolean;
//   Ctrl?
begin

Result := KeyDownly(vk_Control);

end;


//------------------------------------------------------------------------------ Shift
function ShiftDown : Boolean;
//   Shift?
begin

Result := KeyDownly(vk_Shift);

end;



//------------------------------------------------------------------------------ Shift
function AltDown : Boolean;
//   Shift?
begin

Result := KeyDownly(VK_MENU);

end;







{$ENDREGION}






{$REGION '   Color   '}


//------------------------------------------------------------------------------
function cl_Lighter(Color: TColor; Percent: Byte): TColor;
var
  r, g, b, r2, g2, b2: Byte;

begin

Color := ColorToRGB(Color);
r := GetRValue(Color);
g := GetGValue(Color);
b := GetBValue(Color);

r2 := r + muldiv(255 - r, Percent, 100);
if r2 <= r then r2 := $FF;

g2 := g + muldiv(255 - g, Percent, 100);
if g2 <= g then g2 := $FF;

b2 := b + muldiv(255 - b, Percent, 100);
if b2 <= b then b2 := $FF;

result := RGB(r2, g2, b2);

//result := $FFFFFF
end;


//------------------------------------------------------------------------------
function cl_Darker(Color: TColor; Percent: Byte): TColor;
var
  r, g, b: Byte;

begin

Color := ColorToRGB(Color);
r := GetRValue(Color);
g := GetGValue(Color);
b := GetBValue(Color);
r := r - muldiv(r, Percent, 100);
g := g - muldiv(g, Percent, 100);
b := b - muldiv(b, Percent, 100);
result := RGB(r, g, b);

end;


//------------------------------------------------------------------------------
function cl_Lighter2(Color: TColor; Percent: Byte): TColor;
//uses GraphUtil
var
H, L, S: Word;
Clr: Cardinal;

begin

Clr := ColorToRGB(Color);
ColorRGBToHLS(Clr, H, L, S);

if L >= 239
then
begin
  Result := Color;
  exit;
end;

Result := ColorHLSToRGB(H, L + 1, S);

end;


//------------------------------------------------------------------------------
function cl_Darker2(Color: TColor; Percent: Byte): TColor;
//uses GraphUtil
var
H, L, S: Word;
Clr: Cardinal;

begin

Clr := ColorToRGB(Color);
ColorRGBToHLS(Clr, H, L, S);

if L <= 6
then
begin
  Result := Color;
  exit;
end;

Result := ColorHLSToRGB(H, L - 1, S);

end;


//------------------------------------------------------------------------------
function ColorToHtml(const Color: Integer): AnsiString;
const
  Hex = '0123456789ABCDEF';
var
  b, s: Byte;
begin
  Result := '#';
  s := 0;
  repeat
    b := (Color shr s) and $FF;
    Result := Result + Hex[b div 16 + 1] + Hex[b mod 16 + 1];
    Inc(s, 8);
  until s = 24;
end;


{$ENDREGION}






{$REGION '   List   '}



//------------------------------------------------------------------------------ Deselect
procedure List_DeselectAll(List: TListBox);
var i: integer;
begin

if List.SelCount = 0 then exit;

for i := 0 to List.Count - 1
do List.Selected[i] := False;


end;


//------------------------------------------------------------------------------ Invers
procedure List_SelectInvers(List: TListBox);
var i: integer;
begin

if List.SelCount = 0 then exit;

for i := 0 to List.Count - 1
do List.Selected[i] := not List.Selected[i];


end;


//------------------------------------------------------------------------------ Multiselect
procedure List_MultiSelect(List: TListBox; NewRow, OldRow: integer; Button: TMouseButton);
var
i, A, B : integer;
NeedSelect : Boolean;

begin



{Shift}
if ShiftDown
then
begin
     if NewRow > OldRow

     then//
     begin
          A := OldRow;
          B := NewRow;
     end

     else//
     begin
          A := NewRow;
          B := OldRow;
     end;


     NeedSelect := False;

     //  :     
     for i := A to B
     do
     begin
          if not List.Selected[NewRow]
          then
          begin
             List.Selected[i] := true;
             NeedSelect := true;
          end;
     end;

     // c j    ,  DeSelect 
     if NeedSelect = False then
     for i := A to B
     do
     begin
          List.Selected[i] := false;
     end;
     List.Repaint;
     exit;
end;




{Ctrl}
if CtrlDown {or AddToSelected}
then
begin
    //        ,   OldZap
//    if CtrlDown
//    then
//    begin
//        if (Grid.Cols[_zCol_Select].IndexOf(_Zap_SelectYes) = -1) and (NewRow <> OldRow)
//        then Zap_Select(OldRow, True);
//    end;

//    if AddToSelected then Zap_Activate(NewRow);

    List.Selected[NewRow] := not List.Selected[NewRow];

    List.Repaint;
    exit;
end;




if Button = mbLeft //Click
then
begin
    List_DeselectAll(List);
end;



//Smart select by Right mouse.         .
if Button = mbRight //Popup Menu
then
begin
//yy('!!! O_o !!!');

    if not List.Selected[NewRow]
    then
    begin
        List_DeselectAll(List);
        List.Selected[NewRow] := True;

        List.Repaint;
        exit;
    end;
end;



List.Repaint;

end;


//------------------------------------------------------------------------------ Smart Selecet Row
function List_SmartSelectAfterDeleteOne(RowSelected, ListCount: integer; minResult: integer = -1): integer;
//      
begin

if ListCount = 1

then
begin
  Result := -1;
end

else
begin
  if RowSelected = ListCount - 1
  then Result := RowSelected - 2
  else Result := RowSelected;
end;


if Result < minResult then Result := minResult;

end;



{$ENDREGION}






{$REGION '   Int   '}



//------------------------------------------------------------------------------ Random Int
function RandomInt(min, max: integer): integer;
//     min..max
//   RandomRange   Math
begin

Randomize;

if min > max
then Result := Random(min - max) + max
else Result := Random(max - min) + min;

//  :
//i := max - min;
//
//Randomize;
//
//Result := Random(i) + min

end;



//------------------------------------------------------------------------------ is Event
function isEvent(YourInt: integer): Boolean;
// true   , false  
begin
//if trunc((i) / 2) < (i / 2)
//if i mod 2 = 0
//if odd(i)

if (YourInt and 1) = 0
then Result := true  // 
else Result := false // 

end;




{$ENDREGION}






{$REGION     '   Rect   '}




//------------------------------------------------------------------------------
function PointInRect(Point: TPoint; Rect: TRect): boolean;
//     ?
begin
  Result :=
    (Point.x >= Rect.Left)  and
    (Point.y >= Rect.Top)   and
    (Point.x <= Rect.Right) and
    (Point.y <= Rect.Bottom);
end;


//------------------------------------------------------------------------------
function ComponentRect(MyComponent: TWinControl): TRect;
//  ,      
begin

Result := Rect(
                MyComponent.ClientOrigin.X,
                MyComponent.ClientOrigin.Y,
                MyComponent.ClientOrigin.X + MyComponent.Width - 1,
                MyComponent.ClientOrigin.Y + MyComponent.Height - 1
               );
end;



{$ENDREGION}






{$REGION     '   Aver   '}




//------------------------------------------------------------------------------ Resize Split Procent
function ResizeSplitProcent(Procent, Min: integer; Area: integer): integer;
//Area -         %
//        alClient
var
  W, t: integer;

begin

//  ( alClient)
W := Round( Area / 100 * Procent );


//     ,    
if W < Min then W := Min;


//  (alClient),     
t := Area - Min;
if W > t then W := t;


Result := W;

end;


//------------------------------------------------------------------------------
procedure btnColorDrawRect(Btn: TBitBtn; iColor: integer; RectWitdh: integer = -1);
var
  R: TRect;
  i: integer;

begin

if RectWitdh = -1
then Btn.Glyph.Width := Btn.Width  - 8
else Btn.Glyph.Width := RectWitdh;

Btn.Glyph.Height := Btn.Height - 8;

//   fColor.Glyph.AlphaFormat := afIgnored;
//   fColor.Glyph.TransparentColor := not fExample.Font.Color;
Btn.Glyph.TransparentColor := -99000000000;
Btn.Glyph.Transparent := False;
Btn.Glyph.TransparentMode := tmFixed;

i := 2;
R := Rect(i, i, Btn.Glyph.Width - i, Btn.Glyph.Height - i);

Btn.Glyph.Canvas.Brush.Color := iColor;
Btn.Glyph.Canvas.Rectangle(R);

end;


//------------------------------------------------------------------------------
procedure chb_AutoSize(chb: TCheckBox);
var w, h, x2: integer;

begin

w := chb.Width;
h := chb.Height;

chb.Width := Font_Width(chb.Caption, chb.Font) + 18;
chb.Height := Font_Height(chb.Caption, chb.Font) - 1;

if chb.BiDiMode = bdRightToLeft
then chb.Left := chb.Left - (chb.Width - w);

chb.Top := chb.Top - round( (chb.Height - h) / 2);

end;


//------------------------------------------------------------------------------ MMM Widths
procedure MM_Widths(MM: TActionMainMenuBar);
//  
var i, w : integer;

begin

w := 0;
//MM.ActionControls[0].Width := 25;   //  


for i := 0 to MM.ControlCount - 1
do
begin
    // i
    MM.ActionControls[i].Width := Font_Width(MM.ActionControls[i].Caption, mm.Font) + 11;

    //  ,    
    w := w + MM.ActionControls[i].Width;
end;


MM.Width := MM.ControlCount * 8 + w;


end;


//------------------------------------------------------------------------------
function HintWithHotKey(Act: TAction; Dot: Boolean = False): string; overload;
begin

if Dot
then Result := (Act.Caption + '    ' + ShortCutToText(Act.ShortCut)   )
else Result := (Act.Caption + ' (' + ShortCutToText(Act.ShortCut) +')' );

end;



//------------------------------------------------------------------------------
function HintWithHotKey(MenuItem: TMenuItem; Dot: Boolean = False): string; overload;
begin

if Dot
then Result := (MenuItem.Caption + '    ' + ShortCutToText(MenuItem.ShortCut)   )
else Result := (MenuItem.Caption + ' (' + ShortCutToText(MenuItem.ShortCut) +')' );

end;





////------------------------------------------------------------------------------
//function HintingBkt(Act: TAction): string; override;
//begin
//
//Result := (Act.Caption + '  (' + ShortCutToText(Act.ShortCut) + ')');
//
//end;
//
//
//
////------------------------------------------------------------------------------
//function HintingBkt(Text: string): string; override;
//begin
//
////Result := (Text + '  (' + ShortCutToText(Act.ShortCut) + ')');
//Result := (Text + '  (' + ShortCutToText(Act.ShortCut) + ')');
//
//end;



{$ENDREGION}




end.
