unit kuShellDialog;

{
 2013.09.16
    .

:  
kuzduk@mail.ru
kuzduk.000webhostapp.com
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ToolWin, ImgList, Menus,
  PlatformDefaultStyleActnCtrls, ActnPopup, XPStyleActnCtrls, ActnList, ActnMan,

  kuModul,
  kuLanguageUni,
  kuShellListView,
  kuY;

type
  TFormKuShellDialog = class(TForm)
    btnOK: TButton;
    Adres: TEdit;
    ToolBar1: TToolBar;
    ToolButton4: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    pmLVS: TPopupActionBar;
    pmExecute: TMenuItem;
    pmRename: TMenuItem;
    pmDelete: TMenuItem;
    N1: TMenuItem;
    pmNewFolder: TMenuItem;
    pmNewTxt: TMenuItem;
    N13: TMenuItem;
    pmCopy: TMenuItem;
    pmCut: TMenuItem;
    pmPaste: TMenuItem;
    N14: TMenuItem;
    N16: TMenuItem;
    pmRefresh: TMenuItem;
    pmView_SUB: TMenuItem;
    pmStyleTable: TMenuItem;
    pmStyleIcons: TMenuItem;
    pmStyleCols: TMenuItem;
    pmStyleRows: TMenuItem;
    pmHide: TMenuItem;
    pmForm: TPopupActionBar;
    pmForm_Max: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    tbStyle: TToolButton;
    tb_Hide: TToolButton;
    pmStyle: TPopupActionBar;
    pmsIcon: TMenuItem;
    N2: TMenuItem;
    pmsTable: TMenuItem;
    pmsCols: TMenuItem;
    pmsRows: TMenuItem;
    ToolButton15: TToolButton;
    pmOpeninExplorer: TMenuItem;
    ActionManager1: TActionManager;
    Act_LVS_Execute: TAction;
    Act_LVS_Rename: TAction;
    Act_LVS_Delete: TAction;
    Act_LVS_NewFolder: TAction;
    Act_LVS_NewTxt: TAction;
    Act_LVS_Copy: TAction;
    Act_LVS_Cut: TAction;
    Act_LVS_Paste: TAction;
    Act_LVS_Refresh: TAction;
    Act_LVS_OpenInExplorer: TAction;
    Act_LVS_Style_SUB: TAction;
    Act_LVS_StyleTable: TAction;
    Act_LVS_StyleIcons: TAction;
    Act_LVS_StyleCols: TAction;
    Act_LVS_StyleRows: TAction;
    Act_LVS_ShowHide: TAction;
    Act_FormMaximize: TAction;
    icoBtnDirUp: TPanel;
    Act_OK: TAction;
    ToolButton1: TToolButton;
    Act_LVS_Info: TAction;
    Info1: TMenuItem;
    LVS: TkuShellListView;

    procedure FormDestroy(Sender: TObject);
    procedure AdresKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure LVSPathChange(Sender: TObject; OldPath, NewPath: string; var CanChange: Boolean);

    procedure LVSDblClick(Sender: TObject);
    procedure StyleSelecting(ST: TViewStyle);
    procedure LVSStyleChange(Style: TViewStyle);
    procedure icoBtnDirUpClick(Sender: TObject);
    procedure Act_LVS_ExecuteExecute(Sender: TObject);
    procedure Act_LVS_ShowHideExecute(Sender: TObject);
    procedure Act_LVS_OpenInExplorerExecute(Sender: TObject);
    procedure Act_LVS_RefreshExecute(Sender: TObject);
    procedure Act_LVS_PasteExecute(Sender: TObject);
    procedure Act_LVS_CopyExecute(Sender: TObject);
    procedure Act_LVS_CutExecute(Sender: TObject);
    procedure Act_LVS_NewFolderExecute(Sender: TObject);
    procedure Act_LVS_NewTxtExecute(Sender: TObject);
    procedure Act_LVS_DeleteExecute(Sender: TObject);
    procedure Act_LVS_RenameExecute(Sender: TObject);
    procedure Act_LVS_StyleTableExecute(Sender: TObject);
    procedure Act_LVS_StyleIconsExecute(Sender: TObject);
    procedure Act_LVS_StyleColsExecute(Sender: TObject);
    procedure Act_LVS_StyleRowsExecute(Sender: TObject);
    procedure Act_LVS_Style_SUBExecute(Sender: TObject);
    procedure Act_OKExecute(Sender: TObject);
    procedure Act_FormMaximizeExecute(Sender: TObject);
    procedure Act_LVS_InfoExecute(Sender: TObject);
    procedure icoBtnDirUpMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

  end;

var
  FormKuShellDialog: TFormKuShellDialog;
  _KuShellDialog_Result: Boolean = False;

  function kuShellDialogExecute(var SelectedList: TStrings; iCaption: string = 'kuShellDialog'): Boolean;

  
implementation

{$R *.dfm}



//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ku Shell Dialog
function kuShellDialogExecute(var SelectedList: TStrings; iCaption: string = 'kuShellDialog'): Boolean;
begin with FormKuShellDialog do begin


if Application.FindComponent('FormKuShellDialog') = nil
then
begin
  Application.CreateForm(TFormKuShellDialog, FormKuShellDialog);
  Form_iniLoad(FormKuShellDialog);
  LVS.iniLoad('LVS_kuShellDialog', True);

  StyleSelecting(FormKuShellDialog.LVS.ViewStyle);
  Act_LVS_ShowHide.Checked := LVS.ShowHide;

//  LVS.Reload;
//  if DirectoryExists(LVS.Path) then yy(LVS.Path);
end;

FormKuShellDialog.Caption := iCaption;
Lng_Translate_FormKuShellDialog;

//FormKuShellDialog.Adres.Text := FormKuShellDialog.LVS.Path;
FormKuShellDialog.ShowModal;

{ . . . }

if (LVS.Selected <> nil) and _KuShellDialog_Result

then
begin
  LVS.SelectedList(SelectedList, LVS.Path);
  Result := True;
end

else Result := False;

end;end;





{$REGION '   Form   '}



//============================================================================== Destroy
procedure TFormKuShellDialog.FormDestroy(Sender: TObject);
begin
LVS.iniSave('LVS_kuShellDialog');
Form_iniSave(FormKuShellDialog, 'FormKuShellDialog');
end;



//============================================================================== MaxMin
procedure TFormKuShellDialog.Act_FormMaximizeExecute(Sender: TObject);
begin

if FormKuShellDialog.WindowState = wsMaximized

then//
begin
//  Act_Kataloger_Max.ImageIndex := 30;
  FormKuShellDialog.WindowState := wsNormal;
end

else//
begin
//  Act_Kataloger_Max.ImageIndex := 29;
  FormKuShellDialog.WindowState := wsMaximized;
end;

end;



{$ENDREGION}





//------------------------------------------------------------------------------ Dir up
procedure TFormKuShellDialog.icoBtnDirUpClick(Sender: TObject);
begin
LVS.DirUp;
end;



//------------------------------------------------------------------------------
procedure TFormKuShellDialog.icoBtnDirUpMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

if Button = mbMiddle
then
begin
  LVS.Path := '';
end;

end;

//------------------------------------------------------------------------------ Adres Enter
procedure TFormKuShellDialog.AdresKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin

if key = 13
then Adres_Enter(Adres, LVS);

end;


//------------------------------------------------------------------------------ OK
procedure TFormKuShellDialog.Act_OKExecute(Sender: TObject);
begin
_KuShellDialog_Result := True;
FormkuShellDialog.Close;
end;






{$REGION ' LVS '}



//------------------------------------------------------------------------------ Path Change
procedure TFormKuShellDialog.LVSPathChange(Sender: TObject; OldPath, NewPath: string; var CanChange: Boolean);
begin
Adres.Text := NewPath;
end;


//------------------------------------------------------------------------------ Dbl Click
procedure TFormKuShellDialog.LVSDblClick(Sender: TObject);
begin
//if not LVS_isFolder(LVS.Selected) then Act_OK.Execute; //  Drop
end;



//------------------------------------------------------------------------------ On Style Change
procedure TFormKuShellDialog.LVSStyleChange(Style: TViewStyle);
begin
StyleSelecting(Style);
end;


//------------------------------------------------------------------------------ StyleSelecting
procedure TFormKuShellDialog.StyleSelecting(ST: TViewStyle);
begin

case ST
of
  vsReport:
  begin
     tbStyle.ImageIndex := Act_LVS_StyleTable.ImageIndex;
     Act_LVS_StyleTable.Checked := True;
  end;

  vsIcon:
  begin
     tbStyle.ImageIndex := Act_LVS_StyleIcons.ImageIndex;
     Act_LVS_StyleIcons.Checked := True;
  end;

  vsList:
  begin
     tbStyle.ImageIndex := Act_LVS_StyleCols.ImageIndex;
     Act_LVS_StyleCols.Checked := True;
  end;

  vsSmallIcon:
  begin
     tbStyle.ImageIndex := Act_LVS_StyleRows.ImageIndex;
     Act_LVS_StyleRows.Checked := True;
  end;
end;

end;



{$ENDREGION}







{$REGION '   Act   '}



//------------------------------------------------------------------------------ Execute
procedure TFormKuShellDialog.Act_LVS_ExecuteExecute(Sender: TObject);
begin
LVS.ExecuteFile := True;
LVS.Execute;
LVS.ExecuteFile := False;
end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Rename
procedure TFormKuShellDialog.Act_LVS_RenameExecute(Sender: TObject);
begin
LVS.Rename;
end;


//------------------------------------------------------------------------------  Delete
procedure TFormKuShellDialog.Act_LVS_DeleteExecute(Sender: TObject);
begin
LVS.DeleteSelected;
end;





//------------------------------------------------------------------------------ New Folder
procedure TFormKuShellDialog.Act_LVS_NewFolderExecute(Sender: TObject);
begin
LVS.CreateNewFolder;
end;


//------------------------------------------------------------------------------ New txt
procedure TFormKuShellDialog.Act_LVS_NewTxtExecute(Sender: TObject);
begin
LVS.CreateNewTxt;
end;






//------------------------------------------------------------------------------ Copy
procedure TFormKuShellDialog.Act_LVS_CopyExecute(Sender: TObject);
begin
LVS.CopyData;
end;


//------------------------------------------------------------------------------ Cut
procedure TFormKuShellDialog.Act_LVS_CutExecute(Sender: TObject);
begin
LVS.CutData;
end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Paste
procedure TFormKuShellDialog.Act_LVS_PasteExecute(Sender: TObject);
begin
LVS.PasteData;
end;







//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style SUB
procedure TFormKuShellDialog.Act_LVS_Style_SUBExecute(Sender: TObject);
begin
//
end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Icons
procedure TFormKuShellDialog.Act_LVS_StyleIconsExecute(Sender: TObject);
begin
LVS.ViewStyle := vsIcon;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Table
procedure TFormKuShellDialog.Act_LVS_StyleTableExecute(Sender: TObject);
begin
LVS.ViewStyle := vsReport;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Cols
procedure TFormKuShellDialog.Act_LVS_StyleColsExecute(Sender: TObject);
begin
LVS.ViewStyle := vsList;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Rows
procedure TFormKuShellDialog.Act_LVS_StyleRowsExecute(Sender: TObject);begin

LVS.ViewStyle := vsSmallIcon;
LVS.Refresh;

end;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Show hide
procedure TFormKuShellDialog.Act_LVS_ShowHideExecute(Sender: TObject);
begin
LVS.ShowHide := not LVS.ShowHide;
end;





//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Open in Explorer
procedure TFormKuShellDialog.Act_LVS_OpenInExplorerExecute(Sender: TObject);
begin
LVS.OpenInExplorer;
end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Refresh
procedure TFormKuShellDialog.Act_LVS_RefreshExecute(Sender: TObject);
begin
LVS.Reload;
end;


//------------------------------------------------------------------------------ Info
procedure TFormKuShellDialog.Act_LVS_InfoExecute(Sender: TObject);
begin
LVS.Info;
end;





{$ENDREGION}







end.
